<?php
// $Id:

//roles
define('RID_TRADER', 3);
define('RID_COMMITTEE', 4);
define('RID_SYSTEM', 7);

/**
 * implements hook_user_login_block_alter().
 */
function cforge_form_user_login_block_alter(&$form) {
  if (!array_key_exists('destination', $_GET)) {
    //if we are on a user page, stay there, otherwise redirect to news
    if (strpos(current_path(), 'user') !== 0) {
      $form['#action'] = url(current_path(), array('query' => array('destination' => 'news'), 'external' => FALSE));
    }
  }
}

/**
 * Utility
 * @param type $all
 * @return array
 */
function cf_vids($all = FALSE) {
  static $blocks;
  if (!isset($blocks)) {
    global $language;
    $langs = $all ? array_keys(language_list()) : array($language->language);
    $blocks = array();
    if (in_array('fr', $langs)) {
      $blocks['sel_promo'] = array(
        'url' => 'http://www.youtube.com/embed/fwy2sojt3ZM',
        'title' => '',
      );
      $blocks['decouvrir'] = array(
        //'url' => 'http://www.youtube.com/embed/videoseries?list=PLBA6ED7FC6AFC4A2A&amp;hl=en_US',
        'url' => 'http://www.youtube.com/embed/En1RWomDFgI',
        'title' => 'Video découvrir le site',
      );
    }
    if (in_array('es', $langs)) {
      $blocks['cf_training'] = array(
        'url' => 'http://www.youtube.com/embed/pEdk1gct0Iw?list=PL2C2A689416705667',
        'title' => 'Darse de alta en la Central de Talentos',
      );
    }
    if (in_array('en', $langs)) {
      $blocks['nitin'] = array(
        'url' => 'http://www.youtube.com/embed/YvegNqKcQ-g',
        'title' => 'Mutual Credit',
      );
    }
  }
  return $blocks;
}

/**
 * implements hook_block_info().
 */
function cforge_block_info() {
  //these blocks will appear for all languages.
  $blocks = array();
  foreach (cf_vids(TRUE) as $delta => $data) {
    $blocks[$delta] = array(
      'info' => $delta,
      'visibility' => BLOCK_VISIBILITY_LISTED,
      'pages' => "<front>\nLETS\ncommit\nfaq\ngalleries",
      'status' => 1,
    );
  }
  return $blocks;
}


/**
 * implements hook_block_info_alter().
 */
function cforge_block_info_alter(&$blocks, $theme, $code_blocks) {
  if ($theme != variable_get('theme_default')) return;
  $blocks['system']['main-menu']['title'] = '<none>';
  $blocks['search']['form']['title'] =  '<none>';
  $blocks['user']['new']['visibility'] = BLOCK_VISIBILITY_LISTED;
  $blocks['user']['new']['pages'] = "news\nmembers";
  $blocks['user']['new']['user_block_whois_new_count'] = 5;
  $blocks['user']['new']['roles'] = array(DRUPAL_AUTHENTICATED_RID);
  if (isset($blocks['aggregator'])) {
    foreach ($blocks['aggregator'] as $delta => &$info) {
      if ($delta == 'feed1') {
        $info['visibility'] = BLOCK_VISIBILITY_LISTED;
        $info['pages'] = 'news*';
      }
    }
  }
  if (array_key_exists('menu', $blocks)) {
    if (array_key_exists('secondary-menu', $blocks['menu'])) {
      $blocks['menu']['secondary-menu']['title'] = '<none>';
    }
    if (array_key_exists('visitors', $blocks['menu'])) {
      $blocks['menu']['visitors']['title'] = '<none>';
    }
  }
  if (array_key_exists('views', $blocks)) {
    if (array_key_exists('comments_recent-block', $blocks['views'])) {
      $blocks['views']['comments_recent-block']['roles'] =   array(DRUPAL_AUTHENTICATED_RID);
    }
  }
  if (array_key_exists('masquerade', $blocks)) {
    $blocks['masquerade']['masquerade']['roles'] = array(RID_COMMITTEE);
    $blocks['masquerade']['masquerade']['title'] = t('Use the site as');
  }
  //the roles don't make up part of the block_info, so we'll just hard set it here.
  db_delete('block_role')->condition('delta', array('visitors', 'main-menu'))->execute();

  db_insert('block_role')->fields(array('delta','module', 'rid'))
    ->values(array('delta' => 'visitors', 'module' => 'menu', 'rid' => DRUPAL_ANONYMOUS_RID))
    ->values(array('delta' => 'visitors', 'module' => 'menu', 'rid' => RID_COMMITTEE))
    ->values(array('delta' => 'main-menu', 'module' => 'system', 'rid' => DRUPAL_AUTHENTICATED_RID))
    ->execute();


  if (array_key_exists('feed-1', $blocks['aggregator'])) {
    debug( $blocks['aggregator']['feed-1']);
    $blocks['aggregator']['feed-1']['title'] = '<none>';
  }
}

/**
 * implements hook_block_view().
 *
 * Put the menu blocks in place
 */
function cforge_block_view($delta) {
  $vids = cf_vids(FALSE);
  if (!isset($vids[$delta])) {
    return array();
  }
  return array(
    'subject' => isset($vids[$delta]['title']) ? $vids[$delta]['title'] : '<none>',
    'content' => '<iframe width="248" height=184 src="'.$vids[$delta]['url'].'" frameborder="0" allowfullscreen></iframe>'
  );
}

/**
 * Implements hook_block_view_MODULE_DELTA_alter().
 *
 * Change the title of the user block
 */
function cforge_block_view_alter(&$renderable, $block) {
  if ($block->delta =='user-menu') {
    $renderable['subject'] = format_username($GLOBALS['user']);
  }
}

/**
 * Implements views hook_views_api().
 */
function cforge_views_api() {
  return array(
    'api' => 3,
    'path' => drupal_get_path('module', 'cforge'),
  );
}

/**
 * implements hook_cron().
 */
function cforge_cron() {
  db_query('DELETE FROM {sessions} WHERE uid = 0 AND timestamp < :dayago', array(':dayago' => strtotime('-1 day')));
  db_query('DELETE FROM {sessions} WHERE timestamp < :monthago', array(':monthago' => strtotime('-1 month')));
  if (module_exists('watchdog')) {
    db_query('DELETE FROM {watchdog} WHERE timestamp < :weekago', array(':weekago' => strtotime('-1 month')));
  }
  db_query("DELETE FROM cache_form WHERE (expire <> 0) AND (expire < UNIX_TIMESTAMP(NOW()))");
  //delete backups older than 3 months (UNTESTED)
  $backups = backup_migrate_get_saved_backups();
  $cutoff = REQUEST_TIME - (86400*91);
  foreach ($backups[0] as $bkp) {
    if($bkp->file_info['filetime'] < $cutoff) {
      unlink($bkp->path);
    }
  }
  $cssdir = DRUPAL_ROOT.'/'.conf_path().'/files/css';
  if (is_dir($cssdir)) {
    if ($dh = opendir($cssdir)) {
      $files = array();
      while (($file = readdir($dh)) !== false) {
        if ($file != "." && $file != "..") {
          $files[$file] = filemtime($cssdir.'/'.$file);
        }
      }
      $max = max($files);
      foreach ($files as $filename => $time) {
        if ($time < $max) {
          unlink($cssdir.'/'.$filename);
        }
      }
    }
  }
  variable_set('cforge_last_cron', REQUEST_TIME);
}


/**
 * implements hook_init().
 */
function cforge_init() {
  drupal_add_css(drupal_get_path('module', 'cforge').'/cforge.css');
}
/**
 * implements hook_boot().
 *
 * Resets the <front> to the news page for logged in users.
 */
function cforge_boot() {
  if ($GLOBALS['user']->uid) {
    if (empty($_GET['q'])) {
      $_GET['q'] = 'news';
    }
  }
  //defence against certain kinds of bots/crawlers
  elseif (substr_count($_GET['q'], '/') > 5) {//5 is needed for the password reset with language prefix
    drupal_add_http_header('Status', '404 Not Found');
    $fast_404_html = variable_get('404_fast_html', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML+RDFa 1.0//EN" "http://www.w3.org/MarkUp/DTD/xhtml-rdfa-1.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><title>404 Not Found</title></head><body><h1>Not Found</h1><p>The requested URL "@path" was not found on this server.</p></body></html>');
    // Replace @path in the variable with the page path.
    print strtr($fast_404_html, array('@path' => check_plain(request_uri())));
    exit;
  }
}

/**
 * Implements hook_element_info_alter().
 * this is all the code from the disablepwstrength module
 */
function cforge_element_info_alter(&$types) {
  if (isset($types['password_confirm']['#process']) && (($position = array_search('user_form_process_password_confirm', $types['password_confirm']['#process'])) !== FALSE)) {
    unset($types['password_confirm']['#process'][$position]);
  }
}

/**
 * Implements hook_menu().
 */
function cforge_menu() {
  $items = array(
    'admin/config/cforge' => array(
      'title' => 'Cforge settings',
      'description' => 'settings not governed by other modules',
      'page callback' => 'drupal_get_form',
      'page arguments' => array('cforge_settings_form'),
      'access arguments' => array('administer nodes')
    ),
    'hamlets_helpdesk' => array(
      'title' => 'Hamlets helpdesk',
      'description' => 'Give/request help from other users of this software',
      'page callback' => 'drupal_goto',
      'page arguments' => array('http://helpdesk.communityforge.net'),
      'access arguments' => array('administer nodes'),
      'options' => array('attributes' => array('target'=>'_blank')),
      'type' => MENU_CALLBACK,//the link is created elsewhere
    ),
    'robots.txt' => array(
      'page callback' => 'cforge_robots',
      'access callback' => TRUE,
      'type' => MENU_CALLBACK,
    ),
    'cforge/reset' => array(
      'page callback' => 'cforge_reset',
      'access arguments' => array('access administration pages'),
      'type' => MENU_CALLBACK,
      'file' => 'cforge.install'
    ),
    'cforge/README' => array(
      'title callback' => 'echo',//this ain't working
      'title arguments' => array(2),
      'page callback' => 'cforge_readme',
      'page arguments' => array(2),
      'access callback' => TRUE,
      'type' => MENU_CALLBACK,
    ),
    // not finalised yet
    'user/%user/cancel/request' => array(
      'title' => 'Request account cancellation',
      'page callback' => 'cforge_cancel_user_request',
      'page arguments' => array(1),
      'access callback' => TRUE,
      'type' => MENU_CALLBACK,
    )
  );
  return $items;
}

/**
 * implements hook_menu_alter().
 */
function cforge_menu_alter(&$items) {
  module_load_install('cforge');
  cforge_load_frontend();
  $items['user/%/propositions']['weight'] = 1;
  $items['user/%/statement']['weight'] = 2;
  $items['user/%user/contact']['weight'] = 3;

  //committee can re-arrange menu items but not add and remove them through the menu interface
  $items['admin/structure/menu/manage/%menu/add'] ['access arguments'] = array('access administration pages');
  $items['admin/structure/menu/manage/%menu/delete']['access arguments'] = array('access administration pages');
  //this improvement on core makes the menu item visible only if things underneath it are visible
  $items['node/add']['access callback'] = '_cf_add_access';
  //set the order of the user tabs, assuming usertabs has already altered them
  $items['user/%user/account/edit']['title'] = 'Settings';
  $items['user/%user/account/edit']['weight'] = 2;
  $items['user/%user/account/profile']['weight'] = 1;//see cforge_user_categories

  //i think this is a core bug, but we only notice it with i18n
  $items['user/%user/account/profile']['title'] = $items['user/%user/account/profile']['title arguments'][0];
  $items['user/%user/account/manage']['title'] = $items['user/%user/account/manage']['title arguments'][0];
  $items['user/%user/account/profile']['title callback'] = 't';
  $items['user/%user/account/manage']['title callback'] = 't';
  $items['user/%user']['weight'] = '-50';
  $items['user/logout']['weight'] = '50';
  unset($items['taxonomy/term/%taxonomy_term']);
}


/**
 * Implements hook_translated_menu_link_alter().
 */
function cforge_translated_menu_link_alter(&$item) {
  switch($item['link_path']) {
    case 'admin/people/launch':
      $item['title'] = t('Launch');//this shouldn't have been necessary
      break;
    case 'admin/people':
      $item['title'] = t('Manage people');
      break;
    case 'admin/content':
      $item['title'] = t('Manage content');
      break;
    case 'user':
      $item['access'] = $GLOBALS['user']->uid;
      break;
    case 'admin/structure/taxonomy/galleries':
      $item['title'] = t('Manage galleries');
      break;
  }
}

/*
 * Form builder
 */
function cforge_settings_form() {
  $form['mail_footer'] = array(
    '#title' => t('Mail footer'),
    '#description' => t('This will be appended to all automated emails. HTML is allowed.') .' '.t('User tokens refer to the mail recipient, and will break if the recipient mail is not a user.'),
    '#type' => 'fieldset',
    'cforge_mail_footer' => array(
      '#type' => 'textarea',
      '#rows' => 4,
      '#default_value' => variable_get('cforge_mail_footer', '')
    ),
    'cforge_mail_tokens' => array(
      '#theme' => 'token_tree',
      '#token_types' => array('user', 'site'),
      '#global_types' => FALSE,
      '#weight' => 5,
    ),
    '#weight' => 3
  );
  $def = variable_get('cforge_referral', array())
    or $def = array(array('currcode' => 'credunit', 'quantity' => '0'));
  $form['cforge_referral'] = array(
    '#title' => t('Referral fee'),
    '#description' => t('Paid from the reservoir account.'),
    '#type' => 'worths',
    '#default_value' => _worthitems_to_worths($def),
    '#weight' => 1
  );
  $form['cforge_robots_protect'] = array(
    '#title' => t('Conceal from search engines'),
    '#description' => t('Rewrites the robots.txt file'),
    '#type' => 'checkbox',
    '#default_value' => variable_get('cforge_robots_protect', 0),
    '#weight' => 4
  );
  $form['cforge_neighbourhoods'] = array(
    '#title' => t('Neighbourhoods'),
    '#description' => t('Limited list of possible neighbourhoods, one per line. Leave blank to allow a free choice'),
    '#type' => 'textarea',
    '#default_value' => variable_get('cforge_neighbourhoods', ''),
    '#weight' => 2
  );
  return system_settings_form($form);
}

/**
 * Implements hook_user_presave().
 */
function cforge_user_presave(&$edit, &$account, $category = NULL) {
  //the following borrowed from user_user_presave which assumes it knows what categories these things are in.
  if($category == 'manage' && isset($edit['roles'])) {
    $edit['roles'] = array_filter($edit['roles']);
  }
  //fix the username if the address isn't blank
  if (array_key_exists('profile_address', $edit) and $newname = _cforge_make_username($edit['profile_address'])) {
    $edit['name'] = $newname;
  }
  //ensures the next user id is sequential to the last
  if (empty($account->uid)) {
    $account->uid = db_query("SELECT MAX(uid) FROM {users}")->fetchfield() + 1;
    $account->is_new = TRUE;
  }
}

/**
 * Implements hook_node_view_alter().
 */
function cforge_node_view_alter(&$render_array, $view_mode) {
  $render_array['comments']['#weight'] = 19;
  $render_array['links']['#weight'] = 20;
}

/**
 * Implements hook_form_FORM_ID_alter().
 */
function cforge_form_user_profile_form_alter(&$form, &$form_state) {
  $fieldnames = array_keys(field_info_instances('user', 'user'));
  if ($form['#user_category'] == 'account') {
    //the default option - all the user instances are attached in user_profile_form
    //and here we need to block them
    foreach ($fieldnames as $field_name) {
      $form[$field_name]['#access'] = substr($field_name, 0, 7) == 'account';
    }
    $form['account']['roles']['#access'] = FALSE;
    $form['account']['status']['#access'] = FALSE;
    unset($form['ckeditor']);

    //prevent editing of essential user 1 fields
    if ($form['#user']->uid == 1) {
      if ($GLOBALS['user']->uid != 1) {
        $form['account']['pass']['#access'] = FALSE;
        $form['account']['mail']['#access'] = FALSE;
        $form['account']['roles']['#access'] = FALSE;
      }
      $form['account']['status']['#access'] = FALSE;
    }
    //remove the current password validation
    // searches the #validate array for the current_pass validation function, and removes it
    $key = array_search('user_validate_current_pass', $form['#validate']);
    if ($key !== FALSE) {
      unset($form['#validate'][$key]);
    }
    // hide the current password fields
    $form['account']['current_pass_required_value']['#access'] = FALSE;
    $form['account']['current_pass']['#access'] = FALSE;
    //for cosmetic reasons
    $form['account']['roles'][DRUPAL_AUTHENTICATED_RID]['#access'] = FALSE;
  }
  else {
    //get these fields so we can selectively re-add them
    $pseudoform = array('#user' => $form['#user']);
    if($form['#user_category'] == 'manage') {
      user_account_form($pseudoform, $form_state);
      $form['account'] = array(
        'roles' => $pseudoform['account']['roles'],
        'status' => $pseudoform['account']['status']
      );
      $form['account']['roles']['#access'] = user_access('administer users');//otherwise it is 'administer permissions'
    }
    //now load up the fieldnames depending on their prefix
    $categ = substr($form['#user_category'], 0, 5);
    foreach($fieldnames as $field_name) {
      $field_name_prefix = substr($field_name, 0, 5);
      if ($field_name_prefix == 'field')$field_name_prefix = 'profi';
      if ($field_name_prefix == $categ) {
        $options = array('field_name' => $field_name);
        $form += _field_invoke_default('form', 'user', $form['#user'], $form, $form_state, $options);
      }
    }
  }
  _cf_modify_form_profile($form);
  //this is to put the extra_fields on
  $form['#pre_render'][] = '_field_extra_fields_pre_render';
  $form['#entity_type'] = 'user';
  $form['#bundle'] = 'user';
}

/**
 * Implements hook_form_user_register_form_alter().
 */
function cforge_form_user_register_form_alter(&$form) {
  _cf_modify_form_profile($form);
  _cf_add_referrer_field($form);
}
function _cf_add_referrer_field(&$form) {
  $worth = variable_get('cforge_referral', array(array('currcode' => 'credunit', 'quantity' => 0)));
  if (empty($worth) || !isset($worth[0]['quantity']) || $worth[0]['main_quant'] == 0) {
    return;
  }

  $form['cforge_referrer'] = array(
    '#title' => t('Who told you about !site?', array('!site' => variable_get('site_name'))),
    '#description' => t('This member will receive a reward.'),
    '#weight' => 6,
  );
  if ($GLOBALS['user']->uid) {
    $form['cforge_referrer'] += array(
      '#type' => 'user_chooser_few',
      '#callback' => 'user_chooser_segment_roles',
      '#args' => array(RID_TRADER),
      '#required' => FALSE,
    );
    $form['#submit'][] = 'cforge_pay_referrer';
  }
  //anonymous users can't see names of existing users but just submit
  else {
    $form['cforge_referrer'] += array(
      '#type' => 'textfield',
      '#placeholder' => t('Name of member')
    );
    array_unshift($form['#submit'], 'cforge_store_referrer');
  }
}
function cforge_store_referrer($form, $form_state) {
  global $cforge_store_referrer;
  $cforge_store_referrer = $form_state['values']['cforge_referrer'];
}

function cforge_pay_referrer($form, $form_state) {
  $uid = &$form_state['values']['cforge_referrer'];
  $worth = variable_get('cforge_referral', array(
    array('currcode' => 'credunit', 'main_quant' => 0))
  );
  if (!$worth[0]['main_quant'] || !$uid) {
    return;
  }
  //assumes one currency only
  $currency = currency_load($worth[0]['currcode']);
  $props['currcode'] = $worth[0]['currcode'];
  $props['quantity'] = $worth[0]['main_quant'];
  $props['payer'] = currency_load($worth[0]['currcode'])->reservoir;
  $props['payee'] = $uid;
  $props['type'] = 'auto';
  $props['description'] = t('Reward for referring new member !name', array('!name' => $form_state['user']->name));
  $transactions = array(entity_create('transaction', $props));
  transaction_cluster_write($transactions, TRUE);
  drupal_set_message(t('!name was rewarded for referring this member', array('!name' =>user_load($uid)->name)));
}

//modifications to the profile form for both creating and editing.
function _cf_modify_form_profile(&$form) {
  if (in_array($form['#user_category'], array('account', 'register'))) {
    $form['picture']['picture_upload']['#title'] .= ' ('.t('No spaces in filenames!').')';
    $form['account']['name']['#access'] = FALSE;
    $form['contact']['#access'] = FALSE;//everyone can be contacted except offline users
    $form['mimemail']['#access'] = FALSE;//everyone has mimemail
    $form['timezone']['#access'] = FALSE;
    //prevent non-admin from editing account 1 login
    if ($form['#user']->uid == 1 && $GLOBALS['user']->uid != 1) {
      $form['account']['pass']['#type'] == 'hidden';
    }
  }
  if (in_array($form['#user_category'], array('manage', 'register'))) {
    $form['account']['status']['#options'][0] = t('User has not been approved or is no longer a member');
    $form['account']['status']['#options'][1] = t('Normal');
    $form['account']['roles']['#options'][RID_COMMITTEE] = t('Committee: can manage members, articles, pages images, & documents.');
    $form['account']['roles']['#options'][RID_TRADER] = t('Trader: can use the main currency.');
    $form['account']['roles']['#options'][RID_SYSTEM] = t('System: an impersonal account.');
  }
  if (in_array($form['#user_category'], array('profile', 'register'))) {
    //not sure how fields added by user 1 will behave or what the default filter is,
    $lan = $form['profile_phones']['#language'];
    $form['profile_phones'][$lan][0]['#prefix'] = t('Mobile phone');
    if (array_key_exists(1, $form['profile_phones'][$lan])) {
      $form['profile_phones'][$lan][1]['#prefix'] = t('Other phone');
    }

    unset($form['profile_phones'][$lan][0]['_weight']);
    unset($form['profile_phones'][$lan][1]['_weight']);
    $form['profile_phones'][$lan]['#cardinality'] = 1;//spoofs the theming

    if (!module_exists('uid_login')) {
      $form['profile_address'][$form['profile_address']['#language']][0]['#description'] = t("Your login name is derived from your firstname + your family name.");
      if (property_exists($form['#user'], 'name')) {
         $form['profile_address'][$form['profile_address']['#language']][0]['#description'] .= ' '.t("E.g. @name", array('@name' => $form['#user']->name));
      }
    }
    if ($neighbourhoods = variable_get('cforge_neighbourhoods')) {
      $neighbourhood_widget = &$form['profile_address'][$form['profile_address']['#language']][0]['locality_block']['dependent_locality'];
      $neighbourhood_widget['#title'] = t('Neighbourhood');
      $neighbourhood_widget['#type'] = 'select';
      $neighbourhood_widget['#options'] = drupal_map_assoc(preg_split("/\r\n|\n|\r/", $neighbourhoods));
    }
    elseif (user_access('administer nodes')) {
      $form['profile_address'][$form['profile_address']['#language']][0]['locality_block']['dependent_locality']['#description'] = t('Preset the list of neighbourhoods here: @url', array('@url' => url('admin/config/cforge')));
    }

    $form['#validate'][] = 'cforge_check_duplicate_name';
  }
  if ($form['#user_category'] == 'register') {
    $form['account']['name']['#value'] = 'name not yet supplied';
  }
  if ($form['#user_category'] == 'manage') {
    //but I'm hiding the text filter selector anyway for aesthetic reasons. Could also be done in css
    $form['manage_notes'][$form['manage_notes']['#language']][0]['#format'] = 'plain_text';
  }
}

/**
 * Implements hook_user_view_alter().
 */
function cforge_user_view_alter(&$build) {
  unset($build['mimemail']);
}

/**
 * Implements hook_hook_info().
 */
function cforge_hook_info() {
  return array(
    'cf_block_setup' => array(),
    'cf_role_permissions' => array()
  );
}

/**
 * Implements hook_help().
 */
function cforge_help($path, $args) {
  if (substr($path, 0, 6) == 'user/%' && $args[2] != 'signall' && $GLOBALS['user']->uid) {
    $account = user_load($args[1]);
    $title = format_username($account);
    drupal_set_title($title, PASS_THROUGH);
  }
}

/**
 * implements hook_admin_paths_alter().
 */
function cforge_admin_paths_alter(&$paths) {
  $paths['admin/structure/taxonomy/*'] = 1;
  unset($paths['user/*/edit']);
}

/**
 * implements hook_form_FORM_ID_alter().
 */
function cforge_form_user_admin_settings_alter(&$form) {
  unset($form['registration_cancellation']['user_register']['#options'][1]);
  unset($form['registration_cancellation']['#description']);
  $form['registration_cancellation']['#weight'] = -5;
  $form['registration_cancellation']['user_register']['#title'] = t('How to add new members');
  $form['registration_cancellation']['user_register']['#options'][0] = t('Only committee can create accounts');
  $form['registration_cancellation']['user_register']['#options'][2] =t('Anyone can create an account, then a committee member must enable it');
  $form['registration_cancellation']['user_cancel_method']['#access'] = FALSE;
  $form['registration_cancellation']['user_email_verification']['#access'] = FALSE;
  //add a new variable
  $form['registration_cancellation']['cforge_account_manager'] = array(
    '#title' => t('Account manager'),
    '#description' => t('Will receive an email whenever a new account is created'),
    '#type' => 'user_chooser_few',
    '#callback' => 'user_chooser_segment_roles',
    '#args' => array(RID_COMMITTEE),
    '#default_value' => variable_get('cforge_account_manager', ''),
    '#states' => array(
      'visible' => array(
        ':input[name="user_register"]' => array('value' => 2)
      )
    ),
    '#required' => FALSE,//becuase user_chooser makes it required by default
  );

  unset($form['email_no_approval_required']['#access']);
  if ($GLOBALS['user']->uid != 1) {
    $form['registration_cancellation']['#description'] = $form['registration_cancellation']['user_email_verification']['#description'];
    $form['personalization']['#access'] = FALSE;
    $form['contact']['#access'] = FALSE;
    $form['admin_role']['#access'] = FALSE;
  }
}

/**
 * implements hook_form_comment_form_alter().
 */
function cforge_form_comment_form_alter(&$form) {
  unset($form['author']['_author']);
}

/**
 * implements hook_form_FORM_ID_alter().
 */
function cforge_form_node_form_alter(&$form, &$form_state) {
  //set the ckeditor according to node-type
  if (isset($form['body'])) {
    foreach (element_children($form['body']) as $lang) {
      foreach (element_children($form['body'][$lang]) as $delta) {
        $filter = in_array($form['#node']->type, array('page', 'story')) ? 'editor_full_html' : 'editor_filtered_html';
        if (array_key_exists($filter, filter_formats())) {
          $form['body'][$lang][$delta]['#format'] = $filter;
        }
      }
    }
  }
  //forces users to put pages in one of the four flattened menus, and other node types have no menus at all
  if ($form['#node']->type == 'page') {
    //prevent changing the alias of the home page, and remove the delete button
    if ($form['path']['alias']['#default_value'] == drupal_get_path_alias(variable_get('site_frontpage'))) {
      $form['path']['#description'] = '<strong>'. t(
        "Warning: '@name' is your site's front page. If this alias is changed, it should be replaced.",
        array('@name' => $form['path']['alias']['#default_value'])
      ) .'</strong>';
    }

    //flatten the menu, so you can only put things at the top level
    foreach ($form['menu']['link']['parent']['#options'] as $key => $linkname) {
      if (substr($linkname, 0, 2) == '--') {
        unset($form['menu']['link']['parent']['#options'][$key]);
      }
    }
    $form['menu']['link']['parent']['#title'] = t('Put in menu');
    $form['menu']['enabled']['#default_value'] = TRUE;
  }
  else {
    unset($form['menu']);
  }

  //rename the url alias field and explain it better
  if (in_array($form['#node']->type, array('page', 'document', 'story', 'event', 'image'))) {
    $form['path']['alias']['#title'] = t('Friendly address');
    $form['path']['alias']['#description'] = t("Give your page a more memorable address. E.g. 'articles-of-association'");
  }
  else {
    $form['path']['#access'] = FALSE;
  }
}

/**
 * Implements hook_form_FORM_ID_alter().
 */
function cforge_form_taxonomy_overview_vocabularies_alter(&$form, &$form_state, $form_id) {
  foreach (element_children($form) as $key) {
    $form[$key]['edit']['#access'] = user_access('administer taxonomy');
  }
}

/**
 * Implements hook_form_FORM_ID_alter().
 *
 * Remove the search block title
 */
function cforge_form_search_block_form_alter(&$form) {
  if ($GLOBALS['user']->uid != 1) {
    $form['search_block_form']['#title'] = '';
  }
}
/**
 * Implements hook_form_system_site_information_settings_alter().
 */
function cforge_form_system_site_information_settings_alter(&$form, &$form_state) {
  $form['site_information']['cforge_title_hide'] = array(
    '#title' => t('Hide the title and slogan'),
    '#description' => t('For example if your logo image incorporates the title and slogan'),
    '#type' => 'checkbox',
    '#default_value' => variable_get('cforge_title_hide', FALSE),
  );
}
/**
 * Implements hook_preprocess_page().
 */
function cforge_preprocess_page(&$vars) {
  if (variable_get('cforge_title_hide')) {
    $vars['site_name'] = '';
    $vars['site_slogan'] = '';
  }
}

/*
 * Implements hook_form_taxonomy_form_term_alter().
 *
 * Hide the text formatting options for taxonomy_term form
 */
function cforge_form_taxonomy_form_term_alter(&$form) {
  $form['description']['#format'] = 'plain_text';
}
/*
 * Ensure that the user-visible menus are all flat
 */
function cforge_form_menu_edit_item_alter(&$form) {
  if ($GLOBALS['user']->uid != 1) {
    $form['parent']['#options'] = _cf_menu_options();
  }
}

function _cf_menu_options() {
  return db_query("SELECT CONCAT(menu_name,':0'), title
    FROM {menu_custom}
    WHERE menu_name IN ('main-menu', 'secondary-menu', 'user-menu', 'visitors')"
  )->fetchAllKeyed();
}

function cforge_mail($key, &$message, $params) {
  if ($key  == 'request_cancel') {
    $message['subject'] = t('!site account cancellation request', array('!site' => variable_get('site_name')));
    $message['body'][] = t('Dear !name,', array('!name' => format_username(user_load_by_mail($message['to']))));
    $message['body'][] = t('User !name has requested to cancel their account, but their balance is below zero.', array('!name' => format_username($params['account'])));
    $message['body'][] = t('You can delete or disable the account now, but depending on your policy, you might ask them to restore balance either by earning or by paying money');
    $message['body'][] = l(t('Delete or disable'), 'user/'.$params['account']->uid.'/cancel', array('absolute'=> TRUE));
    $message['body'][] = t('When you have decided what to do, let them know by mail: @mail', array('@mail' => $params['account']->mail));
  }
}

/**
 * Implements hook_mail_alter().
 *
 * Add the mail footer.
 */
function cforge_mail_alter(&$message) {
  $key = $message['id'];
  // Remove the unsubscribe message because subscribing is necessary!
  if ($key == 'contact_user_mail') {
    //since the string has already been translated and replacements made, it's rather hard to identify precisely
    unset($message['body'][count($message['body'])-3]);
  }
  elseif($key == 'contact_page_mail') {
    $message['body'][] = $message['from'];
  }
  // Had some confusion what the key should actually be here.
  elseif($key == 'register_pending_approval_admin') {
    //divert it to the accounts manager
    if (variable_get('user_register', 0) == 2) {
      if ($uid = variable_get('cforge_account_manager', '')) {
        $account = user_load($uid);
        $message['to'] = $account->mail;
      }
      else {
        $message['to'] = variable_get('site_mail');
        $account = user_load(1);//this is just to help the mail send
        $message['params']['user'] = $account;
      }
      global $cforge_store_referrer;
      if (!empty($cforge_store_referrer) && !is_numeric($cforge_store_referrer)) {
        $message['body'][] = t(
          'Please pay a referral fee to @name',//unfortunately there is no theme function for worths, only worth
          array('@name' => $cforge_store_referrer)
        );
      }
    }
    else $message['send'] = FALSE;
  }
  if ($key == 'register_admin_created' || $key == 'register_pending_approval') {
    return;
  }
  if (isset($message['params']['user'])) {
    if ($user = user_load_by_mail($message['to'])) {
      $message['params']['user'] = $user;
    }
    else return;
  }
  // Add the footer
  $message['body'][] =  token_replace(
    variable_get('cforge_mail_footer', ''),
    $message['params'],
    array('language' => $message['language'], 'sanitize' => FALSE)
  );
}


/**
 * menu callback
 *
 * Shortcut to the backup & restore module download backup.
 */
function backup_direct() {
  $tables = array('cache', 'cache_admin_menu', 'cache_block', 'cache_bootstrap', 'cache_field', 'cache_filter', 'cache_image', 'cache_menu', 'cache_page', 'cache_path', 'cache_update', 'cache_views', 'cache_views_data', 'watchdog');

  foreach($tables as $table) {
    $queries[] = "TRUNCATE {$table}";
  }
  db_query(implode(';', $queries));
  $form_state['values'] = array(
    'profile_id' => NULL,
    'destination_id' => 'download',
    'source_id' => NULL,
  );
  drupal_form_submit('backup_migrate_ui_manual_quick_backup_form', $form_state);
  drupal_goto(BACKUP_MIGRATE_MENU_PATH .'/restore');
}

/**
 * Overrides theme template_preprocess_username, which truncates the username to
 * 15 chars
 */
function cforge_preprocess_username(&$vars) {
  $vars['uid'] = (int) $vars['account']->uid;
  $vars['name'] = $vars['name_raw'];
}

/**
 * Implements theme hook_process_username().
 */
function cforge_process_username(&$vars) {
  if (!$GLOBALS['user']->uid) {
    $vars['name'] = t('Member @uid', array('@uid' => $vars['account']->uid));
  }
}

/**
 * Implements hook_form_alter().
 *
 * Ensures that anon cannot see usernames, even on the contact form.
 */
function cforge_form_contact_personal_form_alter(&$form, &$form_state) {
  $name = t('Member @uid', array('@uid' => $form_state['build_info']['args'][0]->uid));
  if (!$GLOBALS['user']->uid) {
    drupal_set_title(
     t('Contact @username', array('@username' => $name))
    );
  }
}

/**
 * This special callback determines if the node/add container link is visible
 * not on the basis of whether the user can edit any content types,
 * but on the basis of whether any children of the link can be accessed.
 */
function _cf_add_access() {
  static $access;
  if (!isset($access)) {
    $access = FALSE;
    if (arg(0) == 'admin') {
      $access = TRUE;
    }
    else {
      $mlid = db_select('menu_links', 'ml')->fields('ml', array('mlid'))
        ->condition('link_path', 'node/add')
        ->condition('has_children', 1)
        ->execute()
        ->fetchfield();
      if ($mlid) {
        $children = db_select('menu_links', 'ml')->fields('ml', array('link_path'))->condition('plid', $mlid)->condition('hidden', 0)->execute()->fetchcol();
        foreach ($children as $link_path) {
          if ($link_path == 'node/add/proposition') {
            continue;
          }
          $item = menu_get_item($link_path);
          if ($item['access']) {
            $access = TRUE;
            break;
          }
        }
      }
    }
  }
  return $access;
}

/**
 * menu_callback
 */
function cforge_robots() {
  if (variable_get('cforge_robots_protect')) {
    $txt =  'User-agent: *
Disallow: /';
  }
  else {
    $txt = file_get_contents(DRUPAL_ROOT . '/profiles/cforge/robots.txt');
  }
  drupal_add_http_header('Content-type', 'text/plain');
  print $txt;
  drupal_exit();
}


/**
 * Implements hook_ctools_plugin_directory().
 */
function cforge_ctools_plugin_directory($module, $plugin) {
  if ($module == 'addressfield') {
    return 'plugins/' . $plugin;
  }
}
/**
 * Implements hook_user_categories().
 */
function cforge_user_categories() {
  return array(
    array(
      'name' => 'profile',
      'title' => 'My info',//these are translated by core
      'weight' => 1,
    ),
    array(
      'name' => 'manage',
      'title' => 'Manage',
      'weight' => 3,
      'access callback' => 'user_access',
      'access arguments' => array('administer users')
    )
  );
  t('My info');
  t('Manage');
}

/**
 * implements hook_uchoo_segments().
 */
function cforge_uchoo_segments() {
  return array(
    'user_chooser_segment_neighbourhood' => t('Everyone in the same neighbourhood as the current user')
  );
}
function user_chooser_segment_neighbourhood($query, array $neighbourhoods) {
  //temp filter until user_chooser 1.3 comes through
  if (!array_filter($neighbourhoods)) {
    $items = field_get_items('user', user_load($GLOBALS['user']->uid), 'profile_address');
    $neighbourhoods[] = $items[0]['dependent_locality'];
  }
  $query->join('field_data_profile_address', 'pa', 'pa.entity_id = u.uid');
  $query->condition('profile_address_dependent_locality', $neighbourhoods);//dont' know if it is case sensitive.

}
//in_ version of user_chooser segment
function in_user_chooser_segment_neighbourhood(array $neighbourhoods, $uid = NULL) {
  $account = empty($uid) ? $GLOBALS['user'] : user_load($uid);
  $items = field_get_items('user', $account, 'profile_address');
  return in_array($items[0]['dependent_locality'], $neighbourhoods);
}


/**
 * Implements hook_field_access().
 *
 * only admins can access the manage notes field
 */
function cforge_field_access($op, $field, $entity_type, $entity, $account) {
  if ($entity_type == 'user' && $field['field_name'] == 'manage_notes') {
    return user_access('administer users');
  }
}

/**
 * user profile form validate function
 * because we are manipulating the user names, we need to do our own duplicate check here
 */
function cforge_check_duplicate_name($form, $form_state) {
  $duplicate = db_query(
    "SELECT name FROM {users} where name = :name AND uid != :uid",
    array(
      ':name' => _cforge_make_username($form_state['values']['profile_address']),
      ':uid' => array_key_exists('#user', $form) ? $form['#user']->uid : 0
    )
  )->fetchField();
  if ($duplicate) {
    form_set_error('first_name', t('The name @name is already used.', array('@name' => $duplicate)));
  }
}

function _cforge_make_username($addressfield) {
  $data = current(current($addressfield));
  $username = trim($data['first_name']);
  if (array_key_exists('last_name', $data) && trim($data['last_name'])) {
    $username .= ' '.trim($data['last_name']);
  }
  return $username;
}
/**
 * implements hook_file_download().
 * corrects for a design fault in drupal
 * when the default file wrapper is private, uploaded logos cannot be seen unless access is specifically granted
 * this function reveals all images, by file extension
 */
function cforge_file_download($uri) {
  $info = pathinfo($uri);
  if (in_array($info['extension'], array('gif', 'jpg', 'jpeg', 'png'))) {
    $info = image_get_info($uri);
    return array('Content-Type' => $info['mime_type']);
  }
}

/**
 * Implements hook_form_system_modules_alter().
 *
 * Disable the cforge_hosted checkbox, if present.
 * Add Readme links to the modules page.
 */
function cforge_form_system_modules_alter(&$form, &$form_state) {
  $section = t('Other');
  if (isset($form['modules'][$section]) && array_key_exists('cforge_hosted', $form['modules'][$section])  && $GLOBALS['user']->uid > 1) {
    $form['modules'][$section]['cforge_hosted']['enable']['#disabled'] = TRUE;
  }
  $form['modules']['Community Forge']['#weight'] = -100;
  //add a link to the readme file, similar to the advanced help module
  foreach (element_children($form['modules']) as $group) {
    foreach (element_children($form['modules'][$group]) as $module) {
      $readme = DRUPAL_ROOT .'/'.drupal_get_path('module', $module).'/README.txt';
      if (file_exists($readme)) {
        $form['modules'][$group][$module]['links']['help'] = array(
          '#type' => 'link',
          '#title' => t('README.txt'),
          '#href' => "cforge/README/$module",
          '#options' => array('attributes' => array()),
        );
      }
    }
  }
}

/**
 * Menu callback
 *
 * @param string $module
 *
 * @return string
 */
function cforge_readme($module) {
  $path = drupal_get_path('module', $module).'/README.txt';
  return '<pre>'.file_get_contents($path).'</pre>';
}

/**
 * Get any div tags out of the news teasers
 */
function cforge_process_node($vars) {
  if ($vars['type'] == 'story' && $vars['teaser'] && $vars['body']) {
    $vars['body'][0]['safe_value'] = preg_replace(
      array( '/<div.*?>/', '/<\/div>/'),
      array('', ''),
      $vars['body'][0]['safe_value']
    );
  }
}

/**
 * Implements hook_form_css_injector_edit_alter().
 *
 * Clears the css cache after a modification
 */
function cforge_form_css_injector_edit_alter(&$form, &$form_state) {
  $form['buttons']['save']['#submit'][] = 'drupal_clear_css_cache';
  $form['buttons']['save_and_continue']['#submit'][] = 'drupal_clear_css_cache';
}

/**
 * helper function to build batch emails
 */
function cforge_batch_mail($batch, $module, $key, $accounts, $params, $dest) {
  if ($accounts) {
    foreach ($accounts as $account) {
      // Each mail is one operation
      $batch['operations'][] = array(
        'drupal_mail',
        array(
          $module,
          $key,
          $account->mail, //dest
          user_preferred_language($account),//lang
          $params,//does NOT contain 'account' - same for all mails
          variable_get('site_mail'), //from
          TRUE //really send
        )
      );
    }
    $batch += array(
      'title' => t('Sending @count mails', array('@count' => count($batch['operations']))),
      'error_message' => t('An unrecoverable error has occurred. You can find the error message below. It is advised to copy it to the clipboard for reference.')
    );
    batch_set($batch);
    batch_process($dest);
  }
}

/**
 * Implements form hook_form_user_pass_alter().
 */
function cforge_form_user_pass_alter(&$form, &$form_state) {
  $form['#submit'][] = 'cforge_gmail_spam_warning';
}
/**
 * Form submit callback
 */
function cforge_gmail_spam_warning($form, &$form_state) {
  drupal_set_message(t("If you don't receive an email within a couple of minutes, CHECK YOUR SPAM!"), 'warning');
}

/**
 * Implements hook_captcha_default_points_alter().
 */
function cforge_captcha_default_points_alter(&$items) {
  $keep = array('user_pass', 'user_register_form', 'contact_site_form', 'user_login_block');
  $items = array_intersect_key($items, array_flip($keep));
}

/**
 * Implements hook_form_user_multiple_cancel_confirm_alter().
 */
function cforge_form_user_multiple_cancel_confirm_alter(&$form, &$form_state) {
  $form['user_cancel_confirm']['#access'] = FALSE;
}

/**
 * Implements hook_field_prepare_view().
 *
 * Replace line breaks in the profile_notes field, which is otherwise plain text
 */
function cforge_field_attach_view_alter(&$output, $context) {
  if ($context['entity_type'] == 'user') {
    if (isset($output['profile_notes'])) {
      $output['profile_notes'][0]['#markup'] = str_replace(PHP_EOL, '<br />', $output['profile_notes'][0]['#markup']);
    }
  }
}

/**
 * Implements hook_form_node_admin_content_alter().
 *
 * Remove unnecessary node actions.
 */
function cforge_form_node_admin_content_alter(&$form, $form_state) {
  foreach (['promote', 'demote', 'sticky', 'unsticky'] as $op) {
    unset($form['admin']['options']['operation']['#options'][$op]);
  }
}

/**
 * Implements hook_node_access().
 */
function cforge_node_access($node, $op, $account) {
  //make all nodes private except for page nodes
  if ($op == 'view') {
    return ($node->type == 'page' or (bool)$account->uid);
  }
}

/**
 * Implements hook_user_cancel_methods_alter().
 *
 */
function cforge_user_cancel_methods_alter(&$methods) {
  //Bloquer le membre pour qu'il ne puisse pas se connecter et ne puisse pas être vu, mais conserver ses données et ses transactions. (convient aux membres qui quittent l'association).
  //Supprimer l'utilisateur et supprimer leurs offres et demandes, commentaires et transactions. (Ceci ne devrait être utilisé que pour les comptes spam et les personnes qui ont demandé la suppression de leurs données, à condition que leur compte soit à zéro ou en positif).
  $methods = array(
    'user_cancel_block' => array(
      'title' => t('Prevent the member from logging in or being seen, but keep data and transactions. (suitable for members leaving the association)'),
      'description' =>  t("Your activity will remain in the site history, but you will not longer be a member.")
    ),
    'user_cancel_reassign' => array(
      'title' => t('Delete the member and all their offers, wants & comments. (This should only be used for spam accounts and people who have requested deletion of their data)'),
      'description' => t('Your information will be removed entirely from the site.')
    ),
  );
  // @todo
  //You cannot close your account with a negative balance. The administrator will get in touch with you about settling your account so it can be closed.

}

/**
 * Implements hook_form_user_cancel_confirm_form_alter().
 */
function cforge_form_user_cancel_confirm_form_alter(&$form, &$form_state) {
  $user = $form['_account']['#value'];
  unset($form['user_cancel_confirm']);
  $form['actions']['cancel']['#title'] = t('Back');
  if (user_access('administer users')) {
    $form['description']['#markup'] = $form['user_cancel_method']['#description'];
    debug(1);
  }
  else {
    foreach (array_keys(currencies_load()) as $currcode) {
      // If the user's balance is < 0, replace the cancel button with a request to cancel
      if (transaction_totals($user->uid, $currcode)->balance < 0)  {
        //User delete's own account
        $form['description']['#markup'] = t('You cannot delete this account while it has a positive balance');
        $form['actions']['submit'] = array(
          '#type' => 'submit',
          '#value' => t('Request account cancellation'),
          '#submit' => array('cforge_cancel_user_request')
        );
        unset($form['user_cancel_method']['#description']);
        break;
      }
    }
  }
  unset($form['user_cancel_method']['#description']);
}


/**
 * Menu callback
 *
 * When the user's balance < 0 only an admin can delete the account.
 *
 * @param stdClass $account
 */
function cforge_cancel_user_request(stdClass $account) {
  $committee_uids = db_query("SELECT uid FROM {users_roles} WHERE rid = ".RID_COMMITTEE)->fetchCol();
  foreach (user_load_multiple($committee_uids) as $committee) {
    drupal_mail('cforge', 'request_cancel', $committee->mail, user_preferred_language($committee), array('account' => $account));
  }
  user_logout_current_user();
  drupal_set_message(t('Please wait for a member of the committee to contact you.'));
  drupal_goto();
}


/**
 * Menu callback
 * 
 * @param string $type
 *   one of translations, views, blocks, menu_links and others
 * @param mixed $arg
 *   limit the reset to the named or numbered object
 * @param bool $hard
 *   TRUE to reset back to factory defaults.
 */
function cforge_reset($type, $arg = NULL, $hard = 0) {
  require_once DRUPAL_ROOT . '/includes/install.inc';
  module_load_install('cforge');
  $function = 'cforge_reset_'.$type;
  if (!function_exists($function)) {
    return $function.'() not found';
  }
  $messages = $function($arg, $hard);
  if ($messages) {
    drupal_set_message(implode("\n<br />", $messages));
  }
  if (arg(1) == 'reset') {
    drupal_goto();
  }
}

