<?php


/**
 * Implementation of hook_default_view_views()
 */
function cforge_views_default_views() {
  $view_names = array('member_list', 'news', 'comments_recent', 'last_connection', 'member_count'); //, 'member_dues' is no longer supported because I don't have time.
  foreach($view_names as $name) {
    $function = 'cforge_views_get_'.$name;
    $views[$name] = $function();
  }
  return $views;
}

function cforge_views_get_member_list() {
  $view = new view();
  $view->name = 'member_list';
  $view->description = 'Member list with alpha pagers,';
  $view->tag = 'cforge';
  $view->base_table = 'users';
  $view->human_name = 'Member list';
  $view->core = 0;
  $view->api_version = '3.0';
  $view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */

  /* Display: Defaults */
  $handler = $view->new_display('default', 'Defaults', 'default');
  $d_o = &$handler->display->display_options;
  $d_o['use_more_always'] = FALSE;
  $d_o['use_more_text'] = 'plus';
  $d_o['access']['type'] = 'role';
  $d_o['access']['role'] = array(RID_TRADER => RID_TRADER);
  $d_o['cache']['type'] = 'none';
  $d_o['query']['type'] = 'views_query';
  $d_o['query']['options']['query_comment'] = FALSE;
  $d_o['exposed_form']['type'] = 'basic';
  $d_o['exposed_form']['options']['submit_button'] = 'Apply';
  $d_o['exposed_form']['options']['reset_button_label'] = 'Réinitialiser';
  $d_o['exposed_form']['options']['exposed_sorts_label'] = 'Trier par';
  $d_o['pager']['type'] = 'full';
  $d_o['pager']['options']['items_per_page'] = '25';
  $d_o['pager']['options']['offset'] = '0';
  $d_o['pager']['options']['id'] = '0';
  $d_o['pager']['options']['quantity'] = '100';
  $d_o['pager']['options']['expose']['items_per_page_label'] = 'Éléments par page';
  $d_o['pager']['options']['expose']['items_per_page_options_all_label'] = '- Tout -';
  $d_o['pager']['options']['expose']['offset_label'] = 'Décalage';
  $d_o['pager']['options']['tags']['first'] = '« premier';
  $d_o['pager']['options']['tags']['previous'] = ' précédent';
  $d_o['pager']['options']['tags']['next'] = 'suivant ';
  $d_o['pager']['options']['tags']['last'] = 'dernier »';
  $d_o['style_plugin'] = 'table';
  $d_o['style_options']['default_row_class'] = FALSE;
  $d_o['style_options']['columns'] = array(
    'uid' => 'uid',
    'picture' => 'picture',
    'profile_address_first_name' => 'profile_address_first_name',
    'profile_address_last_name' => 'profile_address_last_name',
    'profile_phones' => 'profile_phones',
    'current_balance' => 'current_balance',
    'current_balance_1' => 'current_balance_1',
    'profile_address_locality' => 'profile_address_locality',
    'limits' => 'limits',
  );
  $d_o['style_options']['default'] = 'profile_address_first_name';
  $d_o['style_options']['info'] = array(
    'uid' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'picture' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'profile_address_first_name' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'profile_address_last_name' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'profile_phones' => array(
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'current_balance' => array(
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'current_balance_1' => array(
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'profile_address_locality' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'limits' => array(
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
  );
  $d_o['style_options']['override'] = FALSE;
  $d_o['style_options']['sticky'] = TRUE;
  /* Footer: Global: Text area */
  $d_o['footer']['area']['id'] = 'area';
  $d_o['footer']['area']['table'] = 'views';
  $d_o['footer']['area']['field'] = 'area';
  $d_o['footer']['area']['label'] = 'GDPR';
  $d_o['footer']['area']['content'] = t('This data should only be shared with members of @site_name', array('@site_name' => variable_get('site_name')));
  $d_o['footer']['area']['format'] = 'editor_filtered_html';
  /* Field: User: Uid */
  $d_o['fields']['uid']['id'] = 'uid';
  $d_o['fields']['uid']['table'] = 'users';
  $d_o['fields']['uid']['field'] = 'uid';
  $d_o['fields']['uid']['label'] = 'N°';
  /* Field: User: Picture */
  $d_o['fields']['picture']['id'] = 'picture';
  $d_o['fields']['picture']['table'] = 'users';
  $d_o['fields']['picture']['field'] = 'picture';
  $d_o['fields']['picture']['label'] = '';
  /* Field: User: Nom et adresse - First name */
  $d_o['fields']['profile_address_first_name']['id'] = 'profile_address_first_name';
  $d_o['fields']['profile_address_first_name']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_first_name']['field'] = 'profile_address_first_name';
  $d_o['fields']['profile_address_first_name']['label'] = 'First name';
  /* Field: User: Nom et adresse - Last name */
  $d_o['fields']['profile_address_last_name']['id'] = 'profile_address_last_name';
  $d_o['fields']['profile_address_last_name']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_last_name']['field'] = 'profile_address_last_name';
  $d_o['fields']['profile_address_last_name']['label'] = 'Last name';
  /* Field: User: Numéros de téléphone */
  $d_o['fields']['profile_phones']['id'] = 'profile_phones';
  $d_o['fields']['profile_phones']['table'] = 'field_data_profile_phones';
  $d_o['fields']['profile_phones']['field'] = 'profile_phones';
  /* Field: User: Transaction statistic */
  $d_o['fields']['current_balance']['id'] = 'current_balance';
  $d_o['fields']['current_balance']['table'] = 'users';
  $d_o['fields']['current_balance']['field'] = 'current_balance';
  $d_o['fields']['current_balance']['label'] = 'Balance';
  $d_o['fields']['current_balance']['currcode'] = array(
    'credunit' => 'credunit',
  );
  /* Field: User: Transaction statistic */
//  $d_o['fields']['current_balance_1']['id'] = 'current_balance_1';
//  $d_o['fields']['current_balance_1']['table'] = 'users';
//  $d_o['fields']['current_balance_1']['field'] = 'current_balance';
//  $d_o['fields']['current_balance_1']['label'] = 'Gross Income';
//  $d_o['fields']['current_balance_1']['total'] = 'gross_in';
//  $d_o['fields']['current_balance_1']['currcode'] = array('credunit' => 'credunit',);
  /* Field: User: Neighbourhood */
  $d_o['fields']['profile_address_locality']['id'] = 'profile_address_dependent_locality';
  $d_o['fields']['profile_address_locality']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_locality']['field'] = 'profile_address_dependent_locality';
  /* Filter criterion: User: Active */
  $d_o['filters']['status']['id'] = 'status';
  $d_o['filters']['status']['table'] = 'users';
  $d_o['filters']['status']['field'] = 'status';
  $d_o['filters']['status']['value'] = '1';
  $d_o['filters']['status']['group'] = '0';
  $d_o['filters']['status']['expose']['operator'] = FALSE;
  /* Filter criterion: User: Roles */
  $d_o['filters']['rid']['id'] = 'rid';
  $d_o['filters']['rid']['table'] = 'users_roles';
  $d_o['filters']['rid']['field'] = 'rid';
  $d_o['filters']['rid']['operator'] = 'not';
  $d_o['filters']['rid']['value'] = array(
    7 => '7',
  );
  $d_o['filters']['rid']['group'] = '0';
  $d_o['filters']['rid']['expose']['operator'] = FALSE;

  /* Display: Page */
  $handler = $view->new_display('page', 'Page', 'page_1');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['title'] = FALSE;
  $d_o['title'] = 'Members';
  $d_o['defaults']['arguments'] = FALSE;
  /* Contextual filter: User: Nom et adresse - First name */
  $d_o['arguments']['profile_address_first_name']['id'] = 'profile_address_first_name';
  $d_o['arguments']['profile_address_first_name']['table'] = 'field_data_profile_address';
  $d_o['arguments']['profile_address_first_name']['field'] = 'profile_address_first_name';
  $d_o['arguments']['profile_address_first_name']['exception']['title'] = 'Tout';
  $d_o['arguments']['profile_address_first_name']['default_argument_type'] = 'fixed';
  $d_o['arguments']['profile_address_first_name']['summary']['number_of_records'] = '0';
  $d_o['arguments']['profile_address_first_name']['summary']['format'] = 'unformatted_summary';
  $d_o['arguments']['profile_address_first_name']['summary_options']['count'] = FALSE;
  $d_o['arguments']['profile_address_first_name']['summary_options']['items_per_page'] = '25';
  $d_o['arguments']['profile_address_first_name']['summary_options']['inline'] = TRUE;
  $d_o['arguments']['profile_address_first_name']['summary_options']['separator'] = ' ';
  $d_o['arguments']['profile_address_first_name']['glossary'] = TRUE;
  $d_o['arguments']['profile_address_first_name']['limit'] = '1';
  $d_o['arguments']['profile_address_first_name']['case'] = 'lower';
  $d_o['arguments']['profile_address_first_name']['path_case'] = 'lower';
  /* Contextual filter: User: Nom et adresse - Last name */
  $d_o['arguments']['profile_address_last_name']['id'] = 'profile_address_last_name';
  $d_o['arguments']['profile_address_last_name']['table'] = 'field_data_profile_address';
  $d_o['arguments']['profile_address_last_name']['field'] = 'profile_address_last_name';
  $d_o['arguments']['profile_address_last_name']['exception']['title'] = 'Tout';
  $d_o['arguments']['profile_address_last_name']['default_argument_type'] = 'fixed';
  $d_o['arguments']['profile_address_last_name']['summary']['number_of_records'] = '0';
  $d_o['arguments']['profile_address_last_name']['summary']['format'] = 'unformatted_summary';
  $d_o['arguments']['profile_address_last_name']['summary_options']['count'] = FALSE;
  $d_o['arguments']['profile_address_last_name']['summary_options']['items_per_page'] = '25';
  $d_o['arguments']['profile_address_last_name']['summary_options']['inline'] = TRUE;
  $d_o['arguments']['profile_address_last_name']['glossary'] = TRUE;
  $d_o['arguments']['profile_address_last_name']['limit'] = '1';
  $d_o['arguments']['profile_address_last_name']['case'] = 'upper';
  $d_o['arguments']['profile_address_last_name']['path_case'] = 'upper';
  $d_o['arguments']['profile_address_last_name']['break_phrase'] = TRUE;
  $d_o['path'] = 'members/all';
  $d_o['menu']['type'] = 'default tab';
  $d_o['menu']['title'] = 'Membres';
  $d_o['menu']['weight'] = '2';
  $d_o['menu']['name'] = 'main-menu';
  $d_o['menu']['context'] = 0;
  $d_o['menu']['context_only_inline'] = 0;
  $d_o['tab_options']['type'] = 'normal';
  $d_o['tab_options']['title'] = 'Membres';
  $d_o['tab_options']['weight'] = '0';
  $d_o['tab_options']['name'] = 'main-menu';

  /* Display: alphapager firstname */
  $handler = $view->new_display('attachment', 'alphapager firstname', 'attachment_1');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['title'] = FALSE;
  $d_o['title'] = 'First name';
  $d_o['pager']['type'] = 'none';
  $d_o['defaults']['header'] = FALSE;
  /* Header: Global: Text area */
  $d_o['header']['text']['id'] = 'area';
  $d_o['header']['text']['table'] = 'views';
  $d_o['header']['text']['field'] = 'area';
  $d_o['header']['text']['content'] = 'First name';
  $d_o['header']['text']['format'] = 'filtered_html';
  $d_o['defaults']['arguments'] = FALSE;
  /* Contextual filter: User: Nom et adresse - First name */
  $d_o['arguments']['profile_address_first_name']['id'] = 'profile_address_first_name';
  $d_o['arguments']['profile_address_first_name']['table'] = 'field_data_profile_address';
  $d_o['arguments']['profile_address_first_name']['field'] = 'profile_address_first_name';
  $d_o['arguments']['profile_address_first_name']['default_action'] = 'summary';
  $d_o['arguments']['profile_address_first_name']['exception']['title'] = 'Tout';
  $d_o['arguments']['profile_address_first_name']['default_argument_type'] = 'fixed';
  $d_o['arguments']['profile_address_first_name']['summary']['number_of_records'] = '0';
  $d_o['arguments']['profile_address_first_name']['summary']['format'] = 'unformatted_summary';
  $d_o['arguments']['profile_address_first_name']['summary_options']['count'] = FALSE;
  $d_o['arguments']['profile_address_first_name']['summary_options']['items_per_page'] = '25';
  $d_o['arguments']['profile_address_first_name']['summary_options']['inline'] = TRUE;
  $d_o['arguments']['profile_address_first_name']['summary_options']['separator'] = ' ';
  $d_o['arguments']['profile_address_first_name']['glossary'] = TRUE;
  $d_o['arguments']['profile_address_first_name']['limit'] = '1';
  $d_o['arguments']['profile_address_first_name']['case'] = 'lower';
  $d_o['arguments']['profile_address_first_name']['path_case'] = 'lower';
  $d_o['arguments']['profile_address_first_name']['break_phrase'] = TRUE;
  $d_o['displays'] = array(
    'page_1' => 'page_1',
    'default' => 0,
    'page_2' => 0,
  );
  $d_o['inherit_arguments'] = FALSE;
  $d_o['render_pager'] = TRUE;

  /* Display: alphapager familyname */
  $handler = $view->new_display('attachment', 'alphapager familyname', 'attachment_2');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['title'] = FALSE;
  $d_o['title'] = 'Family name';
  $d_o['pager']['type'] = 'none';
  $d_o['defaults']['header'] = FALSE;
  /* Header: Global: Text area */
  $d_o['header']['text']['id'] = 'area';
  $d_o['header']['text']['table'] = 'views';
  $d_o['header']['text']['field'] = 'area';
  $d_o['header']['text']['content'] = 'Family name';
  $d_o['header']['text']['format'] = 'filtered_html';
  $d_o['defaults']['arguments'] = FALSE;
  /* Contextual filter: User: Nom et adresse - Last name */
  $d_o['arguments']['profile_address_last_name']['id'] = 'profile_address_last_name';
  $d_o['arguments']['profile_address_last_name']['table'] = 'field_data_profile_address';
  $d_o['arguments']['profile_address_last_name']['field'] = 'profile_address_last_name';
  $d_o['arguments']['profile_address_last_name']['default_action'] = 'summary';
  $d_o['arguments']['profile_address_last_name']['exception']['title'] = 'Tout';
  $d_o['arguments']['profile_address_last_name']['default_argument_type'] = 'fixed';
  $d_o['arguments']['profile_address_last_name']['default_argument_skip_url'] = TRUE;
  $d_o['arguments']['profile_address_last_name']['summary']['number_of_records'] = '0';
  $d_o['arguments']['profile_address_last_name']['summary']['format'] = 'unformatted_summary';
  $d_o['arguments']['profile_address_last_name']['summary_options']['base_path'] = 'members/all/all';
  $d_o['arguments']['profile_address_last_name']['summary_options']['count'] = FALSE;
  $d_o['arguments']['profile_address_last_name']['summary_options']['items_per_page'] = '25';
  $d_o['arguments']['profile_address_last_name']['summary_options']['inline'] = TRUE;
  $d_o['arguments']['profile_address_last_name']['summary_options']['separator'] = ' ';
  $d_o['arguments']['profile_address_last_name']['glossary'] = TRUE;
  $d_o['arguments']['profile_address_last_name']['limit'] = '1';
  $d_o['arguments']['profile_address_last_name']['case'] = 'upper';
  $d_o['arguments']['profile_address_last_name']['path_case'] = 'upper';
  $d_o['arguments']['profile_address_last_name']['break_phrase'] = TRUE;
  $d_o['displays'] = array(
    'page_1' => 'page_1',
  );
  $d_o['inherit_arguments'] = FALSE;

  /* Display: System */
  $handler = $view->new_display('page', 'System', 'page_2');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['title'] = FALSE;
  $d_o['title'] = 'Non-member accounts';
  $d_o['defaults']['arguments'] = FALSE;
  $d_o['defaults']['filter_groups'] = FALSE;
  $d_o['defaults']['filters'] = FALSE;
  /* Filter criterion: User: Active */
  $d_o['filters']['status']['id'] = 'status';
  $d_o['filters']['status']['table'] = 'users';
  $d_o['filters']['status']['field'] = 'status';
  $d_o['filters']['status']['value'] = '1';
  $d_o['filters']['status']['group'] = '0';
  $d_o['filters']['status']['expose']['operator'] = FALSE;
  /* Filter criterion: User: Roles */
  $d_o['filters']['rid']['id'] = 'rid';
  $d_o['filters']['rid']['table'] = 'users_roles';
  $d_o['filters']['rid']['field'] = 'rid';
  $d_o['filters']['rid']['value'] = array(
    7 => 7,
  );
  $d_o['filters']['rid']['group'] = '0';
  $d_o['filters']['rid']['expose']['operator'] = FALSE;
  $d_o['path'] = 'members/system';
  $d_o['menu']['type'] = 'tab';
  $d_o['menu']['title'] = 'System accounts';
  $d_o['menu']['weight'] = '0';

  /* Display: CSV export */
  $handler = $view->new_display('views_data_export', 'CSV export', 'views_data_export_1');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['title'] = FALSE;
  $d_o['title'] = 'All active users';
  $d_o['defaults']['hide_admin_links'] = FALSE;
  $d_o['defaults']['access'] = FALSE;
  $d_o['access']['type'] = 'role';
  $d_o['access']['role'] = array(RID_COMMITTEE => RID_COMMITTEE);
  $d_o['pager']['type'] = 'none';
  $d_o['pager']['options']['offset'] = '0';
  $d_o['style_plugin'] = 'views_data_export_csv';
  $d_o['style_options']['provide_file'] = 1;
  $d_o['style_options']['filename'] = 'members.csv';
  $d_o['style_options']['parent_sort'] = 0;
  $d_o['style_options']['quote'] = 1;
  $d_o['style_options']['trim'] = 0;
  $d_o['style_options']['replace_newlines'] = 1;
  $d_o['style_options']['newline_replacement'] = '\\n';
  $d_o['style_options']['header'] = 1;
  $d_o['defaults']['fields'] = FALSE;
  /* Field: User: Uid */
  $d_o['fields']['uid']['id'] = 'uid';
  $d_o['fields']['uid']['table'] = 'users';
  $d_o['fields']['uid']['field'] = 'uid';
  $d_o['fields']['uid']['label'] = 'N°';
  /* Field: User: Nom et adresse */
  $d_o['fields']['profile_address']['id'] = 'profile_address';
  $d_o['fields']['profile_address']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address']['field'] = 'profile_address';
  $d_o['fields']['profile_address']['label'] = 'First name';
  $d_o['fields']['profile_address']['alter']['alter_text'] = TRUE;
  $d_o['fields']['profile_address']['alter']['text'] = '[profile_address-first_name]';
  $d_o['fields']['profile_address']['settings'] = array(
    'use_widget_handlers' => 1,
    'format_handlers' => array(
      'address' => 'address',
    ),
  );
  /* Field: User: Nom et adresse */
  $d_o['fields']['profile_address_1']['id'] = 'profile_address_1';
  $d_o['fields']['profile_address_1']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_1']['field'] = 'profile_address';
  $d_o['fields']['profile_address_1']['label'] = 'Family name';
  $d_o['fields']['profile_address_1']['alter']['alter_text'] = TRUE;
  $d_o['fields']['profile_address_1']['alter']['text'] = '[profile_address_1-last_name]';
  $d_o['fields']['profile_address_1']['settings'] = array(
    'use_widget_handlers' => 1,
    'format_handlers' => array(
      'address' => 'address',
    ),
  );
  /* Field: User: Transaction statistic */
  $d_o['fields']['current_balance']['id'] = 'current_balance';
  $d_o['fields']['current_balance']['table'] = 'users';
  $d_o['fields']['current_balance']['field'] = 'current_balance';
  $d_o['fields']['current_balance']['label'] = 'Balance';
  $d_o['fields']['current_balance']['strip'] = 1;
  /* Field: User: Transaction statistic */
//  $d_o['fields']['current_balance_1']['id'] = 'current_balance_1';
//  $d_o['fields']['current_balance_1']['table'] = 'users';
//  $d_o['fields']['current_balance_1']['field'] = 'current_balance';
//  $d_o['fields']['current_balance_1']['label'] = 'Gross income';
//  $d_o['fields']['current_balance_1']['total'] = 'gross_in';
//  $d_o['fields']['current_balance_1']['strip'] = 1;
  /* Field: User: E-mail */
  $d_o['fields']['mail']['id'] = 'mail';
  $d_o['fields']['mail']['table'] = 'users';
  $d_o['fields']['mail']['field'] = 'mail';
  $d_o['fields']['mail']['link_to_user'] = '0';
  /* Field: User: Nom et adresse */
  $d_o['fields']['profile_address_2']['id'] = 'profile_address_2';
  $d_o['fields']['profile_address_2']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_2']['field'] = 'profile_address';
  $d_o['fields']['profile_address_2']['label'] = 'Street address';
  $d_o['fields']['profile_address_2']['alter']['alter_text'] = TRUE;
  $d_o['fields']['profile_address_2']['alter']['text'] = '[profile_address_2-thoroughfare]';
  $d_o['fields']['profile_address_2']['settings'] = array(
    'use_widget_handlers' => 1,
    'format_handlers' => array(
      'address' => 'address',
    ),
  );
  /* Field: User: Nom et adresse */
  $d_o['fields']['profile_address_3']['id'] = 'profile_address_3';
  $d_o['fields']['profile_address_3']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_3']['field'] = 'profile_address';
  $d_o['fields']['profile_address_3']['label'] = 'Neighbourhood';
  $d_o['fields']['profile_address_3']['alter']['alter_text'] = TRUE;
  $d_o['fields']['profile_address_3']['alter']['text'] = '[profile_address_3-dependent_locality]';
  $d_o['fields']['profile_address_3']['settings'] = array(
    'use_widget_handlers' => 1,
    'format_handlers' => array(
      'address' => 'address',
    ),
  );
  /* Field: User: Nom et adresse */
  $d_o['fields']['profile_address_4']['id'] = 'profile_address_4';
  $d_o['fields']['profile_address_4']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_4']['field'] = 'profile_address';
  $d_o['fields']['profile_address_4']['label'] = 'Postal code';
  $d_o['fields']['profile_address_4']['alter']['alter_text'] = TRUE;
  $d_o['fields']['profile_address_4']['alter']['text'] = '[profile_address_4-postal_code]';
  $d_o['fields']['profile_address_4']['settings'] = array(
    'use_widget_handlers' => 1,
    'format_handlers' => array(
      'address' => 'address',
    ),
  );
  /* Field: User: Responsabilité */
  $d_o['fields']['manage_responsibility']['id'] = 'manage_responsibility';
  $d_o['fields']['manage_responsibility']['table'] = 'field_data_manage_responsibility';
  $d_o['fields']['manage_responsibility']['field'] = 'manage_responsibility';
  /* Field: User: Numéros de téléphone */
  $d_o['fields']['profile_phones']['id'] = 'profile_phones';
  $d_o['fields']['profile_phones']['table'] = 'field_data_profile_phones';
  $d_o['fields']['profile_phones']['field'] = 'profile_phones';
  $d_o['fields']['profile_phones']['label'] = 'Phones';
  $d_o['fields']['profile_phones']['delta_offset'] = '0';
  /* Field: User: Created date */
  $d_o['fields']['created']['id'] = 'created';
  $d_o['fields']['created']['table'] = 'users';
  $d_o['fields']['created']['field'] = 'created';
  $d_o['fields']['created']['label'] = 'Created';
  $d_o['fields']['created']['date_format'] = 'custom';
  $d_o['fields']['created']['custom_date_format'] = 'd/m/y';
  /* Field: User: Notes (Invisibles pour l'utilisateur) */
  $d_o['fields']['manage_notes']['id'] = 'manage_notes';
  $d_o['fields']['manage_notes']['table'] = 'field_data_manage_notes';
  $d_o['fields']['manage_notes']['field'] = 'manage_notes';
  $d_o['defaults']['filter_groups'] = FALSE;
  $d_o['defaults']['filters'] = FALSE;
  /* Filter criterion: User: Active */
  $d_o['filters']['status']['id'] = 'status';
  $d_o['filters']['status']['table'] = 'users';
  $d_o['filters']['status']['field'] = 'status';
  $d_o['filters']['status']['value'] = '1';
  $d_o['filters']['status']['group'] = '0';
  $d_o['filters']['status']['expose']['operator'] = FALSE;
  $d_o['path'] = 'members.csv';
  $d_o['displays'] = array(
    'page_1' => 'page_1',
    'page_2' => 'page_2',
    'default' => 0,
  );
  $d_o['use_batch'] = 'batch';

  /* Display: print-table */
  $handler = $view->new_display('print-table', 'print-table', 'print-table_1');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['hide_admin_links'] = FALSE;
  $d_o['pager']['type'] = 'none';
  $d_o['pager']['options']['offset'] = '0';
  $d_o['defaults']['access'] = FALSE;
  $d_o['access']['type'] = 'role';
  $d_o['access']['role'] = array(RID_COMMITTEE => RID_COMMITTEE);
  $d_o['defaults']['style_plugin'] = FALSE;
  $d_o['style_plugin'] = 'table';
  $d_o['style_options']['default_row_class'] = FALSE;
  $d_o['style_options']['columns'] = array(
    'uid' => 'uid',
    'picture' => 'picture',
    'profile_address_first_name' => 'profile_address_first_name',
    'profile_address_last_name' => 'profile_address_last_name',
    'profile_phones' => 'profile_phones',
    'current_balance' => 'current_balance',
    'current_balance_1' => 'current_balance_1',
    'profile_address_locality' => 'profile_address_locality',
  );
  $d_o['style_options']['default'] = 'profile_address_first_name';
  $d_o['style_options']['info'] = array(
    'uid' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'picture' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'profile_address_first_name' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'profile_address_last_name' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'profile_phones' => array(
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'current_balance' => array(
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'current_balance_1' => array(
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'profile_address_locality' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
  );
  $d_o['style_options']['override'] = FALSE;
  $d_o['defaults']['style_options'] = FALSE;
  $d_o['defaults']['row_plugin'] = FALSE;
  $d_o['defaults']['row_options'] = FALSE;
  $d_o['defaults']['fields'] = FALSE;
  /* Field: User: Uid */
  $d_o['fields']['uid']['id'] = 'uid';
  $d_o['fields']['uid']['table'] = 'users';
  $d_o['fields']['uid']['field'] = 'uid';
  $d_o['fields']['uid']['label'] = t('N°');
  /* Field: User: Picture */
  $d_o['fields']['picture']['id'] = 'picture';
  $d_o['fields']['picture']['table'] = 'users';
  $d_o['fields']['picture']['field'] = 'picture';
  $d_o['fields']['picture']['label'] = '';
  /* Field: User: Name &amp; Address - First name */
  $d_o['fields']['profile_address_first_name']['id'] = 'profile_address_first_name';
  $d_o['fields']['profile_address_first_name']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_first_name']['field'] = 'profile_address_first_name';
  $d_o['fields']['profile_address_first_name']['label'] = t('First name');
  /* Field: User: Name &amp; Address - Last name */
  $d_o['fields']['profile_address_last_name']['id'] = 'profile_address_last_name';
  $d_o['fields']['profile_address_last_name']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_last_name']['field'] = 'profile_address_last_name';
  $d_o['fields']['profile_address_last_name']['label'] = t('Last name');
  /* Field: User: Phone Numbers */
  $d_o['fields']['profile_phones']['id'] = 'profile_phones';
  $d_o['fields']['profile_phones']['table'] = 'field_data_profile_phones';
  $d_o['fields']['profile_phones']['field'] = 'profile_phones';
  /* Field: User: Transaction statistic */
  $d_o['fields']['current_balance']['id'] = 'current_balance';
  $d_o['fields']['current_balance']['table'] = 'users';
  $d_o['fields']['current_balance']['field'] = 'current_balance';
  $d_o['fields']['current_balance']['label'] = t('Balance');
  $d_o['fields']['current_balance']['currcode'] = array(
    'credunit' => 'credunit',
  );
  /* Field: User: Neighbourhood */
  $d_o['fields']['profile_address_locality']['id'] = 'profile_address_dependent_locality';
  $d_o['fields']['profile_address_locality']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_locality']['field'] = 'profile_address_dependent_locality';
  $d_o['path'] = 'members/print';
  $d_o['displays'] = array(
    'page_1' => 'page_1',
    'default' => 0,
    'page_2' => 0,
    'print-table_1' => 0,
  );


  /* Display: XLS export */
  $handler = $view->new_display('views_data_export', 'XLS export', 'views_data_export_2');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['title'] = FALSE;
  $d_o['title'] = 'All active users';
  $d_o['defaults']['hide_admin_links'] = FALSE;
  $d_o['defaults']['access'] = FALSE;
  $d_o['access']['type'] = 'role';
  $d_o['access']['role'] = array(RID_COMMITTEE => RID_COMMITTEE);
  $d_o['pager']['type'] = 'none';
  $d_o['pager']['options']['offset'] = '0';
  $d_o['style_plugin'] = 'views_data_export_xls';
  $d_o['style_options']['provide_file'] = 1;
  $d_o['style_options']['filename'] = 'membres.xls';
  $d_o['style_options']['parent_sort'] = 0;
  $d_o['defaults']['fields'] = FALSE;
  /* Field: User: Uid */
  $d_o['fields']['uid']['id'] = 'uid';
  $d_o['fields']['uid']['table'] = 'users';
  $d_o['fields']['uid']['field'] = 'uid';
  $d_o['fields']['uid']['label'] = 'N°';
  /* Field: User: Nom et adresse */
  $d_o['fields']['profile_address']['id'] = 'profile_address';
  $d_o['fields']['profile_address']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address']['field'] = 'profile_address';
  $d_o['fields']['profile_address']['label'] = 'First name';
  $d_o['fields']['profile_address']['alter']['alter_text'] = TRUE;
  $d_o['fields']['profile_address']['alter']['text'] = '[profile_address-first_name]';
  $d_o['fields']['profile_address']['click_sort_column'] = 'country';
  $d_o['fields']['profile_address']['settings'] = array(
    'use_widget_handlers' => 1,
    'format_handlers' => array(
      'address' => 'address',
    ),
  );
  /* Field: User: Nom et adresse */
  $d_o['fields']['profile_address_1']['id'] = 'profile_address_1';
  $d_o['fields']['profile_address_1']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_1']['field'] = 'profile_address';
  $d_o['fields']['profile_address_1']['label'] = 'Family name';
  $d_o['fields']['profile_address_1']['alter']['alter_text'] = TRUE;
  $d_o['fields']['profile_address_1']['alter']['text'] = '[profile_address_1-last_name]';
  $d_o['fields']['profile_address_1']['settings'] = array(
    'use_widget_handlers' => 1,
    'format_handlers' => array(
      'address' => 'address',
    ),
  );
  /* Field: User: Nom et adresse */
  $d_o['fields']['profile_address_2']['id'] = 'profile_address_2';
  $d_o['fields']['profile_address_2']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_2']['field'] = 'profile_address';
  $d_o['fields']['profile_address_2']['label'] = 'Street address';
  $d_o['fields']['profile_address_2']['alter']['alter_text'] = TRUE;
  $d_o['fields']['profile_address_2']['alter']['text'] = '[profile_address_2-thoroughfare]';
  $d_o['fields']['profile_address_2']['settings'] = array(
    'use_widget_handlers' => 1,
    'format_handlers' => array(
      'address' => 'address',
    ),
  );
  /* Field: User: Nom et adresse */
  $d_o['fields']['profile_address_4']['id'] = 'profile_address_4';
  $d_o['fields']['profile_address_4']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_4']['field'] = 'profile_address';
  $d_o['fields']['profile_address_4']['label'] = 'Postal code';
  $d_o['fields']['profile_address_4']['alter']['alter_text'] = TRUE;
  $d_o['fields']['profile_address_4']['alter']['text'] = '[profile_address_4-postal_code]';
  $d_o['fields']['profile_address_4']['settings'] = array(
    'use_widget_handlers' => 1,
    'format_handlers' => array(
      'address' => 'address',
    ),
  );
  /* Field: User: Nom et adresse - Locality (i.e. City) */
  $d_o['fields']['profile_address_locality']['id'] = 'profile_address_locality';
  $d_o['fields']['profile_address_locality']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_locality']['field'] = 'profile_address_locality';
  $d_o['fields']['profile_address_locality']['label'] = 'Region';
  /* Field: User: Nom et adresse */
  $d_o['fields']['profile_address_3']['id'] = 'profile_address_3';
  $d_o['fields']['profile_address_3']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_3']['field'] = 'profile_address';
  $d_o['fields']['profile_address_3']['label'] = 'Neighbourhood';
  $d_o['fields']['profile_address_3']['alter']['alter_text'] = TRUE;
  $d_o['fields']['profile_address_3']['alter']['text'] = '[profile_address_3-dependent_locality]';
  $d_o['fields']['profile_address_3']['settings'] = array(
    'use_widget_handlers' => 1,
    'format_handlers' => array(
      'address' => 'address',
    ),
  );
  /* Field: User: Numéros de téléphone */
  $d_o['fields']['profile_phones']['id'] = 'profile_phones';
  $d_o['fields']['profile_phones']['table'] = 'field_data_profile_phones';
  $d_o['fields']['profile_phones']['field'] = 'profile_phones';
  $d_o['fields']['profile_phones']['label'] = 'Phones';
  $d_o['fields']['profile_phones']['delta_offset'] = '0';
  /* Field: User: E-mail */
  $d_o['fields']['mail']['id'] = 'mail';
  $d_o['fields']['mail']['table'] = 'users';
  $d_o['fields']['mail']['field'] = 'mail';
  $d_o['fields']['mail']['link_to_user'] = '0';
  /* Field: User: Transaction statistic */
//  $d_o['fields']['current_balance_1']['id'] = 'current_balance_1';
//  $d_o['fields']['current_balance_1']['table'] = 'users';
//  $d_o['fields']['current_balance_1']['field'] = 'current_balance';
//  $d_o['fields']['current_balance_1']['label'] = 'Gross income';
//  $d_o['fields']['current_balance_1']['total'] = 'gross_in';
//  $d_o['fields']['current_balance_1']['strip'] = 1;
  /* Field: User: Transaction statistic */
  $d_o['fields']['current_balance']['id'] = 'current_balance';
  $d_o['fields']['current_balance']['table'] = 'users';
  $d_o['fields']['current_balance']['field'] = 'current_balance';
  $d_o['fields']['current_balance']['label'] = 'Balance';
  $d_o['fields']['current_balance']['exclude'] = TRUE;
  $d_o['fields']['current_balance']['currcode'] = 'credunit';
  $d_o['fields']['current_balance']['strip'] = 1;
  /* Field: User: Responsabilité */
  $d_o['fields']['manage_responsibility']['id'] = 'manage_responsibility';
  $d_o['fields']['manage_responsibility']['table'] = 'field_data_manage_responsibility';
  $d_o['fields']['manage_responsibility']['field'] = 'manage_responsibility';
  $d_o['fields']['manage_responsibility']['exclude'] = TRUE;
  /* Field: User: Created date */
  $d_o['fields']['created']['id'] = 'created';
  $d_o['fields']['created']['table'] = 'users';
  $d_o['fields']['created']['field'] = 'created';
  $d_o['fields']['created']['label'] = 'Created';
  $d_o['fields']['created']['date_format'] = 'custom';
  $d_o['fields']['created']['custom_date_format'] = 'd/m/y';
  $d_o['defaults']['filter_groups'] = FALSE;
  $d_o['defaults']['filters'] = FALSE;
  /* Filter criterion: User: Active */
  $d_o['filters']['status']['id'] = 'status';
  $d_o['filters']['status']['table'] = 'users';
  $d_o['filters']['status']['field'] = 'status';
  $d_o['filters']['status']['value'] = '1';
  $d_o['filters']['status']['group'] = '0';
  $d_o['filters']['status']['expose']['operator'] = FALSE;
  /* Filter criterion: User: Roles */
  $d_o['filters']['rid']['id'] = 'rid';
  $d_o['filters']['rid']['table'] = 'users_roles';
  $d_o['filters']['rid']['field'] = 'rid';
  $d_o['filters']['rid']['operator'] = 'not';
  $d_o['filters']['rid']['value'] = array(
    7 => '7',
  );
  $d_o['path'] = 'membres.xls';
  $d_o['displays'] = array(
    'page_1' => 'page_1',
    'page_2' => 'page_2',
    'default' => 0,
  );
  $d_o['use_batch'] = 'batch';

  return $view;

  t('N°');
  t('Name');
  t('Balance');
  //t('Gross Income');
  t('Members');
  t('First name');
  t('Family name');
  t('Street address');
  t('Neighbourhood');
  t('Postal code');
  t('Non-member accounts');
  t('All active users');
  t('System accounts');
  t('Phones');
  t('This data should only be shared with members of @site_name');
}


function cforge_views_get_news() {
  $view = new view();
  $view->name = 'recent_news';
  $view->description = 'Latest stories in full, with list of stories';
  $view->tag = 'cforge';
  $view->base_table = 'node';
  $view->human_name = '';
  $view->core = 0;
  $view->api_version = '3.0';
  $view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */

  /* Display: Defaults */
  $handler = $view->new_display('default', 'Defaults', 'default');
  $d_o = &$handler->display->display_options;
  $d_o['title'] = 'News';
  $d_o['use_more'] = TRUE;
  $d_o['use_more_always'] = FALSE;
  $d_o['access']['type'] = 'role';
  $d_o['access']['role'] = array(DRUPAL_AUTHENTICATED_RID => DRUPAL_AUTHENTICATED_RID);
  $d_o['cache']['type'] = 'none';
  $d_o['query']['type'] = 'views_query';
  $d_o['query']['options']['distinct'] = TRUE;
  $d_o['query']['options']['query_comment'] = FALSE;
  $d_o['exposed_form']['type'] = 'basic';
  $d_o['pager']['type'] = 'mini';
  $d_o['pager']['options']['items_per_page'] = '10';
  $d_o['pager']['options']['offset'] = '0';
  $d_o['pager']['options']['id'] = '0';
  $d_o['style_plugin'] = 'default';
  $d_o['row_plugin'] = 'node';
  $d_o['row_options']['view_mode'] = 'full';
  /* Field: Content: Title */
  $d_o['fields']['title']['id'] = 'title';
  $d_o['fields']['title']['table'] = 'node';
  $d_o['fields']['title']['field'] = 'title';
  $d_o['fields']['title']['label'] = '';
  /* Field: Content: Updated date */
  $d_o['fields']['changed']['id'] = 'changed';
  $d_o['fields']['changed']['table'] = 'node';
  $d_o['fields']['changed']['field'] = 'changed';
  /* Sort criterion: Content: Post date */
  $d_o['sorts']['created']['id'] = 'created';
  $d_o['sorts']['created']['table'] = 'node';
  $d_o['sorts']['created']['field'] = 'created';
  $d_o['sorts']['created']['order'] = 'DESC';
  $d_o['sorts']['created']['granularity'] = 'minute';
  /* Filter criterion: Content: Type */
  $d_o['filters']['type']['id'] = 'type';
  $d_o['filters']['type']['table'] = 'node';
  $d_o['filters']['type']['field'] = 'type';
  $d_o['filters']['type']['value'] = array(
    'story' => 'story',
  );
  $d_o['filters']['type']['group'] = '0';
  $d_o['filters']['type']['expose']['operator'] = FALSE;
  /* Filter criterion: Content: Published */
  $d_o['filters']['status']['id'] = 'status';
  $d_o['filters']['status']['table'] = 'node';
  $d_o['filters']['status']['field'] = 'status';
  $d_o['filters']['status']['value'] = '1';

  /* Display: Page */
  $handler = $view->new_display('page', 'Page', 'page_1');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['style_plugin'] = FALSE;
  $d_o['style_plugin'] = 'default';
  $d_o['defaults']['style_options'] = FALSE;
  $d_o['defaults']['row_plugin'] = FALSE;
  $d_o['row_plugin'] = 'node';
  $d_o['defaults']['row_options'] = FALSE;
  $d_o['path'] = 'news';
  $d_o['menu']['type'] = 'normal';
  $d_o['menu']['title'] = 'News';
  $d_o['menu']['weight'] = '0';
  $d_o['menu']['name'] = 'main-menu';
  $d_o['menu']['context'] = 0;
  $d_o['menu']['context_only_inline'] = 0;

  $translatables['recent_news'] = array(
    t('News'),
    t('Offset'),
    t('« first'),
    t('‹ previous'),
    t('next ›'),
    t('last »'),
    t('Updated date'),
    t('Latest stories in full, with list of stories')
  );

  return $view;
}

function cforge_views_get_member_dues() {
  $view = new view;
  $view = new view;
  $view->name = 'member_dues';
  $view->description = 'expiry dates';
  $view->tag = 'cforge';
  $view->base_table = 'users';
  $view->human_name = '';
  $view->core = 0;
  $view->api_version = '3.0';
  $view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */

  /* Display: Default */
  $handler = $view->new_display('default', 'Default', 'default');
  $d_o = &$handler->display->display_options;
  $d_o['title'] = 'Member list';
  $d_o['access']['type'] = 'role';
  $d_o['access']['role'] = array(RID_COMMITTEE => RID_COMMITTEE);
  $d_o['cache']['type'] = 'none';
  $d_o['query']['type'] = 'views_query';
  $d_o['query']['options']['query_comment'] = FALSE;
  $d_o['exposed_form']['type'] = 'basic';
  $d_o['pager']['type'] = 'none';
  $d_o['style_plugin'] = 'table';
  $d_o['style_options']['grouping'] = '';
  $d_o['style_options']['columns'] = array(
    'expiry_timestamp' => 'expiry_timestamp',
    'name' => 'name',
    'value_4' => 'value_4',
    'login' => 'login',
    'cleared_balance' => 'cleared_balance',
  );
  $d_o['style_options']['default'] = 'expiry_timestamp';
  $d_o['style_options']['info'] = array(
    'expiry_timestamp' => array(
      'sortable' => 1,
      'separator' => '',
    ),
    'name' => array(
      'sortable' => 1,
      'separator' => ' ',
    ),
    'value_4' => array(
      'sortable' => 0,
      'separator' => '',
    ),
    'login' => array(
      'sortable' => 1,
      'separator' => '',
    ),
    'cleared_balance' => array(
      'sortable' => 1,
      'separator' => '',
    ),
  );
  $d_o['style_options']['override'] = 1;
  $d_o['style_options']['sticky'] = 0;
  /* Field: User: Role expiration date/time */
  $d_o['fields']['expiry_timestamp']['id'] = 'expiry_timestamp';
  $d_o['fields']['expiry_timestamp']['table'] = 'role_expire';
  $d_o['fields']['expiry_timestamp']['field'] = 'expiry_timestamp';
  $d_o['fields']['expiry_timestamp']['label'] = 'Renewal date';
  $d_o['fields']['expiry_timestamp']['alter']['alter_text'] = 0;
  $d_o['fields']['expiry_timestamp']['alter']['make_link'] = 0;
  $d_o['fields']['expiry_timestamp']['alter']['word_boundary'] = 1;
  $d_o['fields']['expiry_timestamp']['alter']['ellipsis'] = 1;
  $d_o['fields']['expiry_timestamp']['alter']['strip_tags'] = 0;
  $d_o['fields']['expiry_timestamp']['alter']['trim'] = 0;
  $d_o['fields']['expiry_timestamp']['alter']['html'] = 0;
  $d_o['fields']['expiry_timestamp']['hide_empty'] = 0;
  $d_o['fields']['expiry_timestamp']['empty_zero'] = 0;
  $d_o['fields']['expiry_timestamp']['date_format'] = 'medium';
  /* Field: User: Name */
  $d_o['fields']['name']['id'] = 'name';
  $d_o['fields']['name']['table'] = 'users';
  $d_o['fields']['name']['field'] = 'name';
  $d_o['fields']['name']['alter']['alter_text'] = 0;
  $d_o['fields']['name']['alter']['make_link'] = 0;
  $d_o['fields']['name']['alter']['word_boundary'] = 1;
  $d_o['fields']['name']['alter']['ellipsis'] = 1;
  $d_o['fields']['name']['alter']['strip_tags'] = 0;
  $d_o['fields']['name']['alter']['trim'] = 0;
  $d_o['fields']['name']['alter']['html'] = 0;
  $d_o['fields']['name']['link_to_user'] = 1;
  $d_o['fields']['name']['overwrite_anonymous'] = 0;
  /* Field: User: Last login */
  $d_o['fields']['login']['id'] = 'login';
  $d_o['fields']['login']['table'] = 'users';
  $d_o['fields']['login']['field'] = 'login';
  $d_o['fields']['login']['alter']['alter_text'] = 0;
  $d_o['fields']['login']['alter']['make_link'] = 0;
  $d_o['fields']['login']['alter']['word_boundary'] = 1;
  $d_o['fields']['login']['alter']['ellipsis'] = 1;
  $d_o['fields']['login']['alter']['strip_tags'] = 0;
  $d_o['fields']['login']['alter']['trim'] = 0;
  $d_o['fields']['login']['alter']['html'] = 0;
  /* Filter criterion: User: Roles */
  $d_o['filters']['rid']['id'] = 'rid';
  $d_o['filters']['rid']['table'] = 'users_roles';
  $d_o['filters']['rid']['field'] = 'rid';
  $d_o['filters']['rid']['operator'] = 'not';
  $d_o['filters']['rid']['value'] = array(RID_SYSTEM => RID_SYSTEM);
  $d_o['filters']['rid']['group'] = '0';
  $d_o['filters']['rid']['expose']['operator'] = FALSE;
  $d_o['filters']['rid']['reduce_duplicates'] = 0;
  /* Filter criterion: User: Active */
  $d_o['filters']['status']['id'] = 'status';
  $d_o['filters']['status']['table'] = 'users';
  $d_o['filters']['status']['field'] = 'status';
  $d_o['filters']['status']['value'] = '1';
  $d_o['filters']['status']['group'] = '0';
  $d_o['filters']['status']['expose']['operator'] = FALSE;
  /* Filter criterion: User: Role expiration date/time */
  $d_o['filters']['expiry_timestamp']['id'] = 'expiry_timestamp';
  $d_o['filters']['expiry_timestamp']['table'] = 'role_expire';
  $d_o['filters']['expiry_timestamp']['field'] = 'expiry_timestamp';
  $d_o['filters']['expiry_timestamp']['operator'] = '>';
  $d_o['filters']['expiry_timestamp']['value']['value'] = 'now';

  /* Display: Page */
  $handler = $view->new_display('page', 'Page', 'page_1');
  $d_o = &$handler->display->display_options;
  $d_o['path'] = 'members/expiry';
  $d_o['menu']['type'] = 'tab';
  $d_o['menu']['title'] = 'Expiry';
  $d_o['menu']['weight'] = '0';
  $d_o['menu']['name'] = 'manage';

  $translatables = array(
    t('Renewal date'),
    t('Name'),
    t('Last login'),
    t('Expiry')
  );

  return $view;
}

function cforge_views_get_comments_recent() {
  $view = new view();
  $view->name = 'comments_recent';
  $view->description = t('Contains a block and a page to list recent comments; the block will automatically link to the page, which displays the comment body as well as a link to the node.');
  $view->tag = 'default';
  $view->base_table = 'comment';
  $view->human_name = 'Recent comments';
  $view->core = 0;
  $view->api_version = '3.0';
  $view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */

  /* Display: Master */
  $handler = $view->new_display('default', 'Master', 'default');
  $d_o = &$handler->display->display_options;
  $d_o['title'] = 'Recent comments';
  $d_o['use_more'] = TRUE;
  $d_o['use_more_always'] = FALSE;
  $d_o['use_more_text'] = 'plus';
  $d_o['access']['type'] = 'none';
  $d_o['cache']['type'] = 'none';
  $d_o['query']['type'] = 'views_query';
  $d_o['query']['options']['query_comment'] = FALSE;
  $d_o['pager']['type'] = 'some';
  $d_o['pager']['options']['items_per_page'] = 5;
  $d_o['style_plugin'] = 'default';
  $d_o['row_plugin'] = 'fields';
  $d_o['row_options']['inline'] = array(
    'name' => 'name',
    'subject' => 'subject',
  );
  $d_o['row_options']['default_field_elements'] = FALSE;
  /* Relation: Comment : Content */
  $d_o['relationships']['nid']['id'] = 'nid';
  $d_o['relationships']['nid']['table'] = 'comment';
  $d_o['relationships']['nid']['field'] = 'nid';
  /* Field: Contenu : Path */
  $d_o['fields']['path']['id'] = 'path';
  $d_o['fields']['path']['table'] = 'node';
  $d_o['fields']['path']['field'] = 'path';
  $d_o['fields']['path']['relationship'] = 'nid';
  $d_o['fields']['path']['label'] = '';
  $d_o['fields']['path']['exclude'] = TRUE;
  /* Field: Comment : Author */
  $d_o['fields']['name']['id'] = 'name';
  $d_o['fields']['name']['table'] = 'comment';
  $d_o['fields']['name']['field'] = 'name';
  $d_o['fields']['name']['label'] = '';
  $d_o['fields']['name']['exclude'] = TRUE;
  /* Field: Comment : Title */
  $d_o['fields']['subject']['id'] = 'subject';
  $d_o['fields']['subject']['table'] = 'comment';
  $d_o['fields']['subject']['field'] = 'subject';
  $d_o['fields']['subject']['label'] = '';
  $d_o['fields']['subject']['alter']['alter_text'] = TRUE;
  $d_o['fields']['subject']['alter']['text'] = t('[name] said "!whatever_link"', array('@name' => '[name]', '!whatever_link' => '<a href="[path]">[subject]</a>'));

  $d_o['fields']['subject']['element_label_colon'] = FALSE;
  $d_o['fields']['subject']['link_to_comment'] = FALSE;
  /* Sort: Comment : Updated */
  $d_o['sorts']['timestamp']['id'] = 'timestamp';
  $d_o['sorts']['timestamp']['table'] = 'comment';
  $d_o['sorts']['timestamp']['field'] = 'changed';
  $d_o['sorts']['timestamp']['order'] = 'DESC';
  /* Filter: Contenu : Published or admin */
  $d_o['filters']['status_extra']['id'] = 'status_extra';
  $d_o['filters']['status_extra']['table'] = 'node';
  $d_o['filters']['status_extra']['field'] = 'status_extra';
  $d_o['filters']['status_extra']['relationship'] = 'nid';
  $d_o['filters']['status_extra']['group'] = 0;

  /* Display: Page */
  $handler = $view->new_display('page', 'Page', 'page');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['hide_admin_links'] = FALSE;
  $d_o['defaults']['use_more'] = FALSE;
  $d_o['defaults']['use_more_always'] = FALSE;
  $d_o['use_more_always'] = FALSE;
  $d_o['defaults']['use_more_text'] = FALSE;
  $d_o['use_more_text'] = 'plus';
  $d_o['defaults']['pager'] = FALSE;
  $d_o['pager']['type'] = 'full';
  $d_o['pager']['options']['items_per_page'] = '20';
  $d_o['pager']['options']['offset'] = '0';
  $d_o['defaults']['style_plugin'] = FALSE;
  $d_o['style_plugin'] = 'list';
  $d_o['defaults']['style_options'] = FALSE;
  $d_o['defaults']['row_plugin'] = FALSE;
  $d_o['row_plugin'] = 'fields';
  $d_o['row_options']['inline'] = array(
    'title' => 'title',
    'timestamp' => 'timestamp',
  );
  $d_o['row_options']['separator'] = '&nbsp;';
  $d_o['defaults']['row_options'] = FALSE;
  $d_o['defaults']['fields'] = FALSE;
  /* Field: Contenu : Title */
  $d_o['fields']['title']['id'] = 'title';
  $d_o['fields']['title']['table'] = 'node';
  $d_o['fields']['title']['field'] = 'title';
  $d_o['fields']['title']['relationship'] = 'nid';
  $d_o['fields']['title']['label'] = 'Reply to';
  /* Field: Comment : Updated */
  $d_o['fields']['timestamp']['id'] = 'timestamp';
  $d_o['fields']['timestamp']['table'] = 'comment';
  $d_o['fields']['timestamp']['field'] = 'changed';
  $d_o['fields']['timestamp']['label'] = '';
  $d_o['fields']['timestamp']['date_format'] = 'time ago';
  /* Field: Comment : Title */
  $d_o['fields']['subject']['id'] = 'subject';
  $d_o['fields']['subject']['table'] = 'comment';
  $d_o['fields']['subject']['field'] = 'subject';
  $d_o['fields']['subject']['label'] = '';
  /* Field: Comment : Comment */
  $d_o['fields']['comment']['id'] = 'comment';
  $d_o['fields']['comment']['table'] = 'field_data_comment_body';
  $d_o['fields']['comment']['field'] = 'comment_body';
  $d_o['fields']['comment']['label'] = '';
  $d_o['path'] = 'comments/recent';

  /* Display: Block */
  $handler = $view->new_display('block', 'Block', 'block');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['hide_admin_links'] = FALSE;

  return $view;

  $translatables = array(
    t('Recent comments'),
    t('[name] said "<a href="[path]">[subject]</a>"'),
    t('Reply to'),
  );
}

function cforge_views_get_last_connection() {
  $view = new view();
  $view->name = 'recent_connections';
  $view->description = 'Visits in the last 24 hours';
  $view->tag = '';
  $view->base_table = 'users';
  $view->human_name = 'Recent connections';
  $view->core = 0;
  $view->api_version = '3.0';
  $view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */

  /* Display: connexions */
  $handler = $view->new_display('default', 'connexions', 'default');
  $d_o = &$handler->display->display_options;
  $d_o['title'] = 'Visits in the last 24 hours';
  $d_o['items_per_page'] = 0;
  $d_o['use_more_always'] = FALSE;
  $d_o['use_more_text'] = 'plus';
  $d_o['access']['type'] = 'role';
  $d_o['access']['role'] = array(DRUPAL_AUTHENTICATED_RID => DRUPAL_AUTHENTICATED_RID);
  $d_o['cache']['type'] = 'none';
  $d_o['query']['type'] = 'views_query';
  $d_o['exposed_form']['type'] = 'basic';
  $d_o['exposed_form']['options']['submit_button'] = 'Apply';
  $d_o['exposed_form']['options']['reset_button_label'] = 'Reset';
  $d_o['exposed_form']['options']['exposed_sorts_label'] = 'Sort by';
  $d_o['pager']['type'] = 'none';
  $d_o['pager']['options']['offset'] = '0';
  $d_o['style_plugin'] = 'default';
  $d_o['row_plugin'] = 'fields';
  /* Champ: Utilisateur : Nom */
  $d_o['fields']['name']['id'] = 'name';
  $d_o['fields']['name']['table'] = 'users';
  $d_o['fields']['name']['field'] = 'name';
  $d_o['fields']['name']['label'] = '';
  $d_o['fields']['name']['exclude'] = TRUE;
  /* Champ: Utilisateur : Dernière connexion */
  $d_o['fields']['login']['id'] = 'login';
  $d_o['fields']['login']['table'] = 'users';
  $d_o['fields']['login']['field'] = 'login';
  $d_o['fields']['login']['label'] = '';
  $d_o['fields']['login']['alter']['alter_text'] = TRUE;
  $d_o['fields']['login']['alter']['text'] = '<strong><em>[login]</strong></em>  :  [name]';
  $d_o['fields']['login']['date_format'] = 'custom';
  $d_o['fields']['login']['custom_date_format'] = 'd/m h:m';
  /* Critère de tri: Utilisateur : Dernière connexion */
  $d_o['sorts']['login']['id'] = 'login';
  $d_o['sorts']['login']['table'] = 'users';
  $d_o['sorts']['login']['field'] = 'login';
  $d_o['sorts']['login']['order'] = 'DESC';
  /* Filtre contextuel: Utilisateur : Uid */
  $d_o['arguments']['uid']['id'] = 'uid';
  $d_o['arguments']['uid']['table'] = 'users';
  $d_o['arguments']['uid']['field'] = 'uid';
  $d_o['arguments']['uid']['exception']['title'] = 'All';
  $d_o['arguments']['uid']['default_argument_type'] = 'fixed';
  $d_o['arguments']['uid']['summary']['format'] = 'default_summary';
  /* Filtre contextuel: Utilisateur : Uid */
  $d_o['arguments']['uid_1']['id'] = 'uid_1';
  $d_o['arguments']['uid_1']['table'] = 'users';
  $d_o['arguments']['uid_1']['field'] = 'uid';
  $d_o['arguments']['uid_1']['exception']['title'] = 'All';
  $d_o['arguments']['uid_1']['default_argument_type'] = 'fixed';
  $d_o['arguments']['uid_1']['summary']['format'] = 'default_summary';
  /* Critère de filtrage: Utilisateur : Actif */
  $d_o['filters']['status']['id'] = 'status';
  $d_o['filters']['status']['table'] = 'users';
  $d_o['filters']['status']['field'] = 'status';
  /* Critère de filtrage: Utilisateur : Dernière connexion */
  $d_o['filters']['login']['id'] = 'login';
  $d_o['filters']['login']['table'] = 'users';
  $d_o['filters']['login']['field'] = 'login';
  $d_o['filters']['login']['operator'] = '>=';
  $d_o['filters']['login']['value']['value'] = '-1 day';
  $d_o['filters']['login']['value']['type'] = 'offset';
  $d_o['filters']['login']['group'] = '0';
  $d_o['filters']['login']['expose']['operator'] = FALSE;

  /* Display: bloc connexion today */
  $handler = $view->new_display('block', 'bloc connexion today', 'block_1');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['title'] = FALSE;
  $d_o['title'] = 'Visits in the last 24 hours';
  $d_o['defaults']['hide_admin_links'] = FALSE;
  $d_o['defaults']['header'] = FALSE;
  $d_o['defaults']['relationships'] = FALSE;
  $d_o['defaults']['fields'] = FALSE;
  /* Champ: Utilisateur : Nom */
  $d_o['fields']['name']['id'] = 'name';
  $d_o['fields']['name']['table'] = 'users';
  $d_o['fields']['name']['field'] = 'name';
  $d_o['fields']['name']['label'] = '';
  $d_o['fields']['name']['exclude'] = TRUE;
  $d_o['fields']['name']['hide_alter_empty'] = FALSE;
  /* Champ: Utilisateur : Dernière connexion */
  $d_o['fields']['login']['id'] = 'login';
  $d_o['fields']['login']['table'] = 'users';
  $d_o['fields']['login']['field'] = 'login';
  $d_o['fields']['login']['label'] = '';
  $d_o['fields']['login']['alter']['alter_text'] = TRUE;
  $d_o['fields']['login']['alter']['text'] = '<strong><em>[login]</strong></em>  :  [name]';
  $d_o['fields']['login']['element_label_colon'] = FALSE;
  $d_o['fields']['login']['hide_alter_empty'] = FALSE;
  $d_o['fields']['login']['date_format'] = 'custom';
  $d_o['fields']['login']['custom_date_format'] = 'H:i';
  $d_o['defaults']['filter_groups'] = FALSE;
  $d_o['defaults']['filters'] = FALSE;
  /* Critère de filtrage: Utilisateur : Actif */
  $d_o['filters']['status']['id'] = 'status';
  $d_o['filters']['status']['table'] = 'users';
  $d_o['filters']['status']['field'] = 'status';
  $d_o['filters']['status']['value'] = '1';
  $d_o['filters']['status']['group'] = '0';
  $d_o['filters']['status']['expose']['operator'] = FALSE;
  /* Critère de filtrage: Utilisateur : Dernière connexion */
  $d_o['filters']['login']['id'] = 'login';
  $d_o['filters']['login']['table'] = 'users';
  $d_o['filters']['login']['field'] = 'login';
  $d_o['filters']['login']['operator'] = '>=';
  $d_o['filters']['login']['value']['value'] = '-24 hours ';
  $d_o['filters']['login']['value']['type'] = 'offset';
  $d_o['filters']['login']['group'] = '0';
  $d_o['filters']['login']['expose']['operator'] = FALSE;
  $d_o['block_description'] = 'Visits in the last 24 hours';

  return $view;

 t('Visits in the last 24 hours');//Connexions ces dernières 24h :
 t('Recent connections');
}

function cforge_views_get_member_count() {
  $view = new view();
  $view->name = 'member_count';
  $view->description = 'Number of active members';
  $view->tag = 'default';
  $view->base_table = 'users';
  $view->human_name = 'Number of active members';
  $view->core = 7;
  $view->api_version = '3.0';
  $view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */

  /* Display: Master */
  $handler = $view->new_display('default', 'Master', 'default');
  $d_o = &$handler->display->display_options;
  $d_o['title'] = 'Number of active members';
  $d_o['use_more_always'] = FALSE;
  $d_o['use_more_text'] = 'plus';
  $d_o['group_by'] = TRUE;
  $d_o['access']['type'] = 'role';
  $d_o['access']['role'] = array(
   DRUPAL_ANONYMOUS_RID => DRUPAL_ANONYMOUS_RID,
   DRUPAL_AUTHENTICATED_RID => DRUPAL_AUTHENTICATED_RID,
  );
  $d_o['cache']['type'] = 'none';
  $d_o['query']['type'] = 'views_query';
  $d_o['exposed_form']['type'] = 'basic';
  $d_o['exposed_form']['options']['submit_button'] = 'Apply';
  $d_o['exposed_form']['options']['reset_button_label'] = 'Reset';
  $d_o['exposed_form']['options']['exposed_sorts_label'] = 'Sort by';
  $d_o['pager']['type'] = 'some';
  $d_o['pager']['options']['items_per_page'] = '';
  $d_o['pager']['options']['offset'] = '0';
  $d_o['style_plugin'] = 'default';
  $d_o['row_plugin'] = 'fields';
  /* Champ: COUNT(DISTINCT Utilisateur : Uid) */
  $d_o['fields']['uid']['id'] = 'uid';
  $d_o['fields']['uid']['table'] = 'users';
  $d_o['fields']['uid']['field'] = 'uid';
  $d_o['fields']['uid']['group_type'] = 'count_distinct';
  $d_o['fields']['uid']['label'] = '';
  $d_o['fields']['uid']['alter']['alter_text'] = TRUE;
  $d_o['fields']['uid']['alter']['text'] = '<strong>We are [uid] members</strong>';
  $d_o['fields']['uid']['element_label_colon'] = FALSE;
  /* Critère de filtrage: Utilisateur : Actif */
  $d_o['filters']['status']['id'] = 'status';
  $d_o['filters']['status']['table'] = 'users';
  $d_o['filters']['status']['field'] = 'status';
  $d_o['filters']['status']['value'] = '1';
  $d_o['filters']['status']['group'] = 1;
  $d_o['filters']['status']['expose']['operator'] = FALSE;
  /* Critère de filtrage: Utilisateur : Rôles */
  $d_o['filters']['rid']['id'] = 'rid';
  $d_o['filters']['rid']['table'] = 'users_roles';
  $d_o['filters']['rid']['field'] = 'rid';
  $d_o['filters']['rid']['operator'] = 'not';
  $d_o['filters']['rid']['value'] = array(
   7 => '7',
  );

  /* Display: Block */
  $handler = $view->new_display('block', 'Block', 'block');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['hide_admin_links'] = FALSE;
  $d_o['block_description'] = 'Number of active members';

  return $view;

 t('Number of active members');//Nombre de membres actifs
 t('<strong>We are [uid] members</strong>');//Nous sommes [uid] membres
}
