<?php
//ensure we have the role id constants
module_load_include('profile', 'cforge');

/**
 * Implementation of hook_default_view_views_alter()
 */
function cforge_currencies_views_default_views_alter(&$views) {

  $view = new view();
  $view->name = 'transactions';
  $view->description = '';
  $view->tag = 'mcapi';
  $view->base_table = 'mcapi_transactions';
  $view->human_name = 'Transactions';
  $view->core = 7;
  $view->api_version = '3.0';
  $view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */

  /* Display: Master */
  $handler = $view->new_display('default', 'Master', 'default');
  $d_o = &$handler->display->display_options;
  $d_o['title'] = 'Transactions';
  $d_o['access']['type'] = 'none';
  $d_o['access']['type'] = 'role';
  $d_o['access']['role'] = array(
    DRUPAL_AUTHENTICATED_RID => DRUPAL_AUTHENTICATED_RID,
  );
  $d_o['cache']['type'] = 'none';
  $d_o['query']['type'] = 'views_query';
  $d_o['query']['options']['query_comment'] = FALSE;
  $d_o['exposed_form']['type'] = 'basic';
  $d_o['pager']['type'] = 'full';
  $d_o['pager']['options']['items_per_page'] = '25';
  $d_o['style_plugin'] = 'table';
  $d_o['style_options']['columns'] = array(
    'name' => 'name',
    'name_1' => 'name_1',
    'transaction_description' => 'transaction_description',
    'worth' => 'worth',
    'view' => 'view',
  );

  /* Comportement en l'absence de résultats: Global : Texte non filtré */
  $d_o['empty']['area_text_custom']['id'] = 'area_text_custom';
  $d_o['empty']['area_text_custom']['table'] = 'views';
  $d_o['empty']['area_text_custom']['field'] = 'area_text_custom';
  $d_o['empty']['area_text_custom']['empty'] = TRUE;
  $d_o['empty']['area_text_custom']['content'] = 'No transactions';
  $d_o['empty']['area_text_custom']['format'] = 'filtered_html';

  /* Relationship: Transaction: Payee */
  $d_o['relationships']['payee']['id'] = 'payee';
  $d_o['relationships']['payee']['table'] = 'mcapi_transactions';
  $d_o['relationships']['payee']['field'] = 'payee';
  $d_o['relationships']['payee']['required'] = 0;
  /* Relationship: Transaction: Payer */
  $d_o['relationships']['payer']['id'] = 'payer';
  $d_o['relationships']['payer']['table'] = 'mcapi_transactions';
  $d_o['relationships']['payer']['field'] = 'payer';
  $d_o['relationships']['payer']['required'] = 0;


  /* Field: Transaction: Created */
  $d_o['fields']['created']['id'] = 'created';
  $d_o['fields']['created']['table'] = 'mcapi_transactions';
  $d_o['fields']['created']['field'] = 'created';
  $d_o['fields']['created']['date_format'] = 'short';
  /* Field: Transaction: Serial number */
  $d_o['fields']['serial']['id'] = 'serial';
  $d_o['fields']['serial']['table'] = 'mcapi_transactions';
  $d_o['fields']['serial']['field'] = 'serial';
  $d_o['fields']['serial']['link_to_transaction'] = 1;
  /* Field: User: Name */
  $d_o['fields']['name']['id'] = 'name';
  $d_o['fields']['name']['table'] = 'users';
  $d_o['fields']['name']['field'] = 'name';
  $d_o['fields']['name']['relationship'] = 'payee';
  $d_o['fields']['name']['label'] = 'Payee';
  /* Field: User: Name */
  $d_o['fields']['name_1']['id'] = 'name_1';
  $d_o['fields']['name_1']['table'] = 'users';
  $d_o['fields']['name_1']['field'] = 'name';
  $d_o['fields']['name_1']['relationship'] = 'payer';
  $d_o['fields']['name_1']['label'] = 'Payer';
  /* Field: Transaction: Description */
  $d_o['fields']['transaction_description']['id'] = 'transaction_description';
  $d_o['fields']['transaction_description']['table'] = 'field_data_transaction_description';
  $d_o['fields']['transaction_description']['field'] = 'transaction_description';
  $d_o['fields']['transaction_description']['label'] = 'Description';
  /* Field: Transaction: Worth */
  $d_o['fields']['worth']['id'] = 'worth';
  $d_o['fields']['worth']['table'] = 'field_data_worth';
  $d_o['fields']['worth']['field'] = 'worth';
  $d_o['fields']['worth']['element_label_colon'] = 1;
  $d_o['fields']['worth']['element_default_classes'] = 1;
  $d_o['fields']['worth']['hide_empty'] = 0;
  $d_o['fields']['worth']['empty_zero'] = 0;
  $d_o['fields']['worth']['hide_alter_empty'] = 1;
  $d_o['fields']['worth']['click_sort_column'] = 'currcode';
  $d_o['fields']['worth']['type'] = 'worth_field';
  $d_o['fields']['worth']['field_api_classes'] = 0;
  /* Field: Transaction: Operations */
  $d_o['fields']['operations']['id'] = 'operations';
  $d_o['fields']['operations']['table'] = 'mcapi_transactions';
  $d_o['fields']['operations']['field'] = 'operations';
  $d_o['fields']['operations']['link_to_transaction'] = 0;
  /* Sort criterion: Transaction: created */
  $d_o['sorts']['created']['id'] = 'created';
  $d_o['sorts']['created']['table'] = 'mcapi_transactions';
  $d_o['sorts']['created']['field'] = 'created';
  $d_o['sorts']['created']['order'] = 'DESC';
  $d_o['sorts']['created']['granularity'] = 'hour';
  /* Filter criterion: Transaction: State */
  $d_o['filters']['state']['id'] = 'state';
  $d_o['filters']['state']['table'] = 'mcapi_transactions';
  $d_o['filters']['state']['field'] = 'state';
  $d_o['filters']['state']['value'] = array(
    TRANSACTION_STATE_FINISHED => TRANSACTION_STATE_FINISHED,
  );
  /* Filter criterion: Transaction: Type */
  $d_o['filters']['type']['id'] = 'type';
  $d_o['filters']['type']['table'] = 'mcapi_transactions';
  $d_o['filters']['type']['field'] = 'type';
  $d_o['filters']['type']['operator'] = 'not in';
  $d_o['filters']['type']['value'] = array(
    'child' => 'child',
    'mass' => 'mass',
  );
  $d_o['filters']['type']['expose']['operator_id'] = 'type_op';
  $d_o['filters']['type']['expose']['label'] = 'Type';
  $d_o['filters']['type']['expose']['use_operator'] = FALSE;
  $d_o['filters']['type']['expose']['operator'] = 'type_op';
  $d_o['filters']['type']['expose']['identifier'] = 'type';
  $d_o['filters']['type']['expose']['required'] = FALSE;
  $d_o['filters']['type']['expose']['remember'] = FALSE;
  $d_o['filters']['type']['expose']['multiple'] = FALSE;

  /* Display: Transactions */
  $handler = $view->new_display('page', t('Transactions'), 'transactions');
  $d_o = &$handler->display->display_options;
  $d_o['path'] = 'transactions/log';
  $d_o['menu']['type'] = 'default tab';
  $d_o['menu']['title'] = t('Log');
  $d_o['menu']['weight'] = 0;
  $d_o['menu']['name'] = 'main-menu';
  $d_o['menu']['context'] = 0;
  $d_o['menu']['context_only_inline'] = 0;
  $d_o['tab_options']['type'] = 'normal';
  $d_o['tab_options']['title'] = t('Transactions');
  $d_o['tab_options']['weight'] = '5';
  $d_o['tab_options']['name'] = 'main-menu';

  /* Display: Who gave what */
  $handler = $view->new_display('block', 'Who gave what', 'who_gave_what');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['hide_admin_links'] = FALSE;
  $d_o['defaults']['access'] = FALSE;
  $d_o['access']['type'] = 'none';
  $d_o['defaults']['pager'] = FALSE;
  $d_o['pager']['type'] = 'some';
  $d_o['pager']['options']['items_per_page'] = '5';
  $d_o['pager']['options']['offset'] = '0';
  $d_o['defaults']['style_plugin'] = FALSE;
  $d_o['style_plugin'] = 'list';
  $d_o['style_options']['default_row_class'] = FALSE;
  $d_o['style_options']['row_class_special'] = FALSE;
  $d_o['defaults']['style_options'] = FALSE;
  $d_o['defaults']['row_plugin'] = FALSE;
  $d_o['row_plugin'] = 'fields';
  $d_o['row_options']['inline'] = array(
    'name' => 'name',
    'transaction_description' => 'transaction_description',
  );
  $d_o['defaults']['row_options'] = FALSE;
  $d_o['defaults']['fields'] = FALSE;
  /* Field: User: Nom */
  $d_o['fields']['name']['id'] = 'name';
  $d_o['fields']['name']['table'] = 'users';
  $d_o['fields']['name']['field'] = 'name';
  $d_o['fields']['name']['relationship'] = 'payee';
  $d_o['fields']['name']['label'] = '';
  $d_o['fields']['name']['exclude'] = TRUE;
  $d_o['fields']['name']['element_label_colon'] = FALSE;
  /* Field: Transaction: Description */
  $d_o['fields']['transaction_description']['id'] = 'transaction_description';
  $d_o['fields']['transaction_description']['table'] = 'field_data_transaction_description';
  $d_o['fields']['transaction_description']['field'] = 'transaction_description';
  $d_o['fields']['transaction_description']['label'] = '';
  $d_o['fields']['transaction_description']['alter']['alter_text'] = TRUE;
  $d_o['fields']['transaction_description']['alter']['text'] = "[name] gave [transaction_description]";
  $d_o['fields']['transaction_description']['element_label_colon'] = FALSE;

  $views[$view->name] = $view;

  $translatables['transactions'] = array(
    t('Payee'),
    t('Payer'),
    t('Serial number'),
    t('Name'),
    t('Worth'),
    t('Log'),
    t('Transactions'),
    t('No transactions'),
    t('[name] gave [transaction_description]'),
  );



  drupal_load('profile', 'cforge');//for the constants
  $view = new view();
  $view->name = 'transactions_all';
  $view->description = 'For admin or accountant to manage transactions';
  $view->tag = 'mcapi';
  $view->base_table = 'mcapi_transactions';
  $view->human_name = 'Generate transaction report';
  $view->core = 7;
  $view->api_version = '3.0';
  $view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */

  /* Display: Master */
  $handler = $view->new_display('default', 'Master', 'default');
  $d_o = &$handler->display->display_options;
  $d_o['title'] = 'Transaction reports';
  $d_o['use_more_always'] = FALSE;
  $d_o['use_more_text'] = 'plus';
  $d_o['access']['type'] = 'role';
  $d_o['access']['role'] = array(
    4 => '4',
    8 => '8',
  );
  $d_o['cache']['type'] = 'none';
  $d_o['query']['type'] = 'views_query';
  $d_o['query']['options']['query_comment'] = FALSE;
  $d_o['exposed_form']['type'] = 'basic';
  $d_o['pager']['type'] = 'full';
  $d_o['pager']['options']['items_per_page'] = '50';
  $d_o['style_plugin'] = 'table';
  $d_o['style_options']['columns'] = array(
    'created' => 'created',
    'payee' => 'payee',
    'payer' => 'payer',
    'type' => 'type',
    'state' => 'state',
    'worth' => 'worth',
    'field_cat' => 'field_cat',
  );
  $d_o['style_options']['default'] = 'created';
  $d_o['style_options']['info'] = array(
    'participant' => array(
      'sortable' => 0,
      'align' => '',
      'separator' => '',
    ),
    'payee' => array(
      'sortable' => 0,
      'align' => '',
      'separator' => '',
    ),
    'payer' => array(
      'sortable' => 0,
      'align' => '',
      'separator' => '',
    ),
    'created' => array(
      'sortable' => 1,
      'default_sort_order' => 'desc',
      'align' => '',
      'separator' => '',
    ),
    'type' => array(
      'sortable' => 0,
      'align' => '',
      'separator' => '',
    ),
    'state' => array(
      'sortable' => 0,
      'align' => '',
      'separator' => '',
    ),
    'worth' => array(
      'sortable' => 0,
      'align' => '',
      'separator' => '',
    ),
  );
  $d_o['style_options']['sticky'] = TRUE;
  $d_o['style_options']['order'] = 'desc';
  $d_o['style_options']['summary'] = 'All transactions, filtered';
  /* Header: Global: Text area */
  $d_o['header']['area']['id'] = 'area';
  $d_o['header']['area']['table'] = 'views';
  $d_o['header']['area']['field'] = 'area';
  $d_o['header']['area']['content'] = 'All transactions can be seen from here. Use the filters to list what you need.';
  /* Relationship: Transaction: Payee */
  $d_o['relationships']['payee']['id'] = 'payee';
  $d_o['relationships']['payee']['table'] = 'mcapi_transactions';
  $d_o['relationships']['payee']['field'] = 'payee';
  $d_o['relationships']['payee']['required'] = TRUE;
  /* Relationship: Transaction: Payer */
  $d_o['relationships']['payer']['id'] = 'payer';
  $d_o['relationships']['payer']['table'] = 'mcapi_transactions';
  $d_o['relationships']['payer']['field'] = 'payer';
  $d_o['relationships']['payer']['required'] = TRUE;
  /* Field: Transaction: Created */
  $d_o['fields']['created']['id'] = 'created';
  $d_o['fields']['created']['table'] = 'mcapi_transactions';
  $d_o['fields']['created']['field'] = 'created';
  $d_o['fields']['created']['label'] = 'Recorded';
  $d_o['fields']['created']['date_format'] = 'short';
  /* Field: Transaction: Serial */
  $d_o['fields']['serial']['id'] = 'serial';
  $d_o['fields']['serial']['table'] = 'mcapi_transactions';
  $d_o['fields']['serial']['field'] = 'serial';
  $d_o['fields']['serial']['exclude'] = TRUE;
  $d_o['fields']['serial']['element_label_colon'] = FALSE;
  $d_o['fields']['serial']['link_to_transaction'] = 0;
  /* Field: User: Name */
  $d_o['fields']['name_1']['id'] = 'name_1';
  $d_o['fields']['name_1']['table'] = 'users';
  $d_o['fields']['name_1']['field'] = 'name';
  $d_o['fields']['name_1']['relationship'] = 'payer';
  $d_o['fields']['name_1']['label'] = 'Payer';
  $d_o['fields']['name_1']['hide_alter_empty'] = FALSE;
  /* Field: User: Name */
  $d_o['fields']['name']['id'] = 'name';
  $d_o['fields']['name']['table'] = 'users';
  $d_o['fields']['name']['field'] = 'name';
  $d_o['fields']['name']['relationship'] = 'payee';
  $d_o['fields']['name']['label'] = 'Payee';
  $d_o['fields']['name']['hide_alter_empty'] = FALSE;
  /* Field: Transaction: Valeur */
  $d_o['fields']['worth']['id'] = 'worth';
  $d_o['fields']['worth']['table'] = 'field_data_worth';
  $d_o['fields']['worth']['field'] = 'worth';
  $d_o['fields']['worth']['element_default_classes'] = FALSE;
  $d_o['fields']['worth']['hide_alter_empty'] = FALSE;
  $d_o['fields']['worth']['click_sort_column'] = 'currcode';
  /* Field: Transaction: Description */
  $d_o['fields']['transaction_description']['id'] = 'transaction_description';
  $d_o['fields']['transaction_description']['table'] = 'field_data_transaction_description';
  $d_o['fields']['transaction_description']['field'] = 'transaction_description';
  $d_o['fields']['transaction_description']['label'] = '';
  $d_o['fields']['transaction_description']['alter']['make_link'] = TRUE;
  $d_o['fields']['transaction_description']['alter']['path'] = 'transaction/[serial]';
  $d_o['fields']['transaction_description']['element_label_colon'] = FALSE;
  $d_o['fields']['transaction_description']['type'] = 'text_plain';
  $d_o['fields']['transaction_description']['settings'] = array(
    'trim_length' => '600',
  );
  /* Field: Transaction: State */
  $d_o['fields']['state']['id'] = 'state';
  $d_o['fields']['state']['table'] = 'mcapi_transactions';
  $d_o['fields']['state']['field'] = 'state';
  $d_o['fields']['state']['element_label_colon'] = FALSE;
  /* Field: Transaction: Type */
  $d_o['fields']['type']['id'] = 'type';
  $d_o['fields']['type']['table'] = 'mcapi_transactions';
  $d_o['fields']['type']['field'] = 'type';
  $d_o['fields']['type']['element_label_colon'] = FALSE;
  /* Field: Transaction: Operations */
  $d_o['fields']['operations']['id'] = 'operations';
  $d_o['fields']['operations']['table'] = 'mcapi_transactions';
  $d_o['fields']['operations']['field'] = 'operations';
  $d_o['fields']['operations']['label'] = '';
  $d_o['fields']['operations']['element_label_colon'] = FALSE;
  $d_o['fields']['operations']['link_to_transaction'] = 0;
  /* Sort criterion: Transaction: Created */
  $d_o['sorts']['created']['id'] = 'created';
  $d_o['sorts']['created']['table'] = 'mcapi_transactions';
  $d_o['sorts']['created']['field'] = 'created';
  $d_o['sorts']['created']['order'] = 'DESC';
  $d_o['sorts']['created']['granularity'] = 'minute';
  /* Filter criterion: Transaction: Type */
  $d_o['filters']['type']['id'] = 'type';
  $d_o['filters']['type']['table'] = 'mcapi_transactions';
  $d_o['filters']['type']['field'] = 'type';
  $d_o['filters']['type']['group'] = 0;
  $d_o['filters']['type']['exposed'] = TRUE;
  $d_o['filters']['type']['expose']['operator_id'] = 'type_op';
  $d_o['filters']['type']['expose']['label'] = 'Type';
  $d_o['filters']['type']['expose']['operator'] = 'type_op';
  $d_o['filters']['type']['expose']['identifier'] = 'type';
  $d_o['filters']['type']['expose']['multiple'] = TRUE;
  /* Filter criterion: User: Name */
  $d_o['filters']['uid']['id'] = 'uid';
  $d_o['filters']['uid']['table'] = 'users';
  $d_o['filters']['uid']['field'] = 'uid';
  $d_o['filters']['uid']['relationship'] = 'payee';
  $d_o['filters']['uid']['value'] = '';
  $d_o['filters']['uid']['group'] = 0;
  $d_o['filters']['uid']['exposed'] = TRUE;
  $d_o['filters']['uid']['expose']['operator_id'] = 'uid_op';
  $d_o['filters']['uid']['expose']['label'] = 'Payee';
  $d_o['filters']['uid']['expose']['operator'] = 'uid_op';
  $d_o['filters']['uid']['expose']['identifier'] = 'uid';
  /* Filter criterion: User: Name */
  $d_o['filters']['uid_1']['id'] = 'uid_1';
  $d_o['filters']['uid_1']['table'] = 'users';
  $d_o['filters']['uid_1']['field'] = 'uid';
  $d_o['filters']['uid_1']['relationship'] = 'payer';
  $d_o['filters']['uid_1']['value'] = '';
  $d_o['filters']['uid_1']['exposed'] = TRUE;
  $d_o['filters']['uid_1']['expose']['operator_id'] = 'uid_1_op';
  $d_o['filters']['uid_1']['expose']['label'] = 'Payer';
  $d_o['filters']['uid_1']['expose']['operator'] = 'uid_1_op';
  $d_o['filters']['uid_1']['expose']['identifier'] = 'uid_1';
  /* Filter criterion: Transaction: State */
  $d_o['filters']['state']['id'] = 'state';
  $d_o['filters']['state']['table'] = 'mcapi_transactions';
  $d_o['filters']['state']['field'] = 'state';
  $d_o['filters']['state']['value'] = array(
    0 => 1,
  );
  $d_o['filters']['state']['exposed'] = TRUE;
  $d_o['filters']['state']['expose']['operator_id'] = '';
  $d_o['filters']['state']['expose']['label'] = 'State';
  $d_o['filters']['state']['expose']['operator'] = 'state_op';
  $d_o['filters']['state']['expose']['identifier'] = 'state';
  /* Filter criterion: Transaction: Valeur (worth:quantity) */
  $d_o['filters']['worth_quantity']['id'] = 'worth_quantity';
  $d_o['filters']['worth_quantity']['table'] = 'field_data_worth';
  $d_o['filters']['worth_quantity']['field'] = 'worth_quantity';
  $d_o['filters']['worth_quantity']['exposed'] = TRUE;
  $d_o['filters']['worth_quantity']['expose']['operator_id'] = 'worth_quantity_op';
  $d_o['filters']['worth_quantity']['expose']['label'] = 'Quantity';
  $d_o['filters']['worth_quantity']['expose']['use_operator'] = TRUE;
  $d_o['filters']['worth_quantity']['expose']['operator'] = 'worth_quantity_op';
  $d_o['filters']['worth_quantity']['expose']['identifier'] = 'worth_quantity';

  /* Display: Page */
  $handler = $view->new_display('page', 'Page', 'page');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['footer'] = FALSE;
  /* Footer: Global: Text area */
  $d_o['footer']['area']['id'] = 'area';
  $d_o['footer']['area']['table'] = 'views';
  $d_o['footer']['area']['field'] = 'area';
  $d_o['footer']['area']['label'] = 'GDPR';
  $d_o['footer']['area']['content'] = t('This data should only be shared with members of @site_name', array('@site_name' => variable_get('site_name')));
  $d_o['footer']['area']['format'] = 'editor_filtered_html';

  $d_o['path'] = 'transactions/report';
  $d_o['menu']['type'] = 'tab';
  $d_o['menu']['title'] = 'Report';
  $d_o['menu']['description'] = 'Vue d\'échanges avec tous les filtres exposés';
  $d_o['menu']['weight'] = '0';
  $d_o['menu']['name'] = 'secondary-menu';
  $d_o['menu']['context'] = 0;
  $d_o['menu']['context_only_inline'] = 0;

  /* Display: Data export */
  $handler = $view->new_display('views_data_export', 'Data export', 'views_data_export_1');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['hide_admin_links'] = FALSE;
  $d_o['pager']['type'] = 'none';
  $d_o['pager']['options']['offset'] = '0';
  $d_o['style_plugin'] = 'views_data_export_csv';
  $d_o['style_options']['attach_text'] = 'Fichier .csv';
  $d_o['style_options']['provide_file'] = 1;
  $d_o['style_options']['filename'] = 'transactions.csv';
  $d_o['style_options']['parent_sort'] = 0;
  $d_o['style_options']['quote'] = 1;
  $d_o['style_options']['trim'] = 0;
  $d_o['style_options']['replace_newlines'] = 1;
  $d_o['style_options']['newline_replacement'] = '\\n';
  $d_o['style_options']['header'] = 1;
  $d_o['style_options']['keep_html'] = 0;
  $d_o['defaults']['fields'] = FALSE;
  /* Field: Transaction: Created */
  $d_o['fields']['created']['id'] = 'created';
  $d_o['fields']['created']['table'] = 'mcapi_transactions';
  $d_o['fields']['created']['field'] = 'created';
  $d_o['fields']['created']['label'] = 'Recorded';
  $d_o['fields']['created']['date_format'] = 'short';
  /* Field: Transaction: Serial */
  $d_o['fields']['serial']['id'] = 'serial';
  $d_o['fields']['serial']['table'] = 'mcapi_transactions';
  $d_o['fields']['serial']['field'] = 'serial';
  $d_o['fields']['serial']['exclude'] = TRUE;
  $d_o['fields']['serial']['element_label_colon'] = FALSE;
  $d_o['fields']['serial']['link_to_transaction'] = 0;
  /* Field: User: E-mail */
  $d_o['fields']['mail_1']['id'] = 'mail_1';
  $d_o['fields']['mail_1']['table'] = 'users';
  $d_o['fields']['mail_1']['field'] = 'mail';
  $d_o['fields']['mail_1']['relationship'] = 'payer';
  $d_o['fields']['mail_1']['label'] = 'Payer';
  $d_o['fields']['mail_1']['link_to_user'] = '0';
  /* Field: User: E-mail */
  $d_o['fields']['mail']['id'] = 'mail';
  $d_o['fields']['mail']['table'] = 'users';
  $d_o['fields']['mail']['field'] = 'mail';
  $d_o['fields']['mail']['relationship'] = 'payee';
  $d_o['fields']['mail']['label'] = 'Payee';
  $d_o['fields']['mail']['link_to_user'] = '0';
  /* Field: Transaction: Valeur */
  $d_o['fields']['worth']['id'] = 'worth';
  $d_o['fields']['worth']['table'] = 'field_data_worth';
  $d_o['fields']['worth']['field'] = 'worth';
  $d_o['fields']['worth']['element_default_classes'] = FALSE;
  $d_o['fields']['worth']['hide_alter_empty'] = FALSE;
  $d_o['fields']['worth']['click_sort_column'] = 'currcode';
  /* Field: Transaction: Description */
  $d_o['fields']['transaction_description']['id'] = 'transaction_description';
  $d_o['fields']['transaction_description']['table'] = 'field_data_transaction_description';
  $d_o['fields']['transaction_description']['field'] = 'transaction_description';
  $d_o['fields']['transaction_description']['label'] = '';
  $d_o['fields']['transaction_description']['alter']['make_link'] = TRUE;
  $d_o['fields']['transaction_description']['alter']['path'] = 'transaction/[serial]';
  $d_o['fields']['transaction_description']['element_label_colon'] = FALSE;
  $d_o['fields']['transaction_description']['type'] = 'text_plain';
  $d_o['fields']['transaction_description']['settings'] = array(
    'trim_length' => '600',
  );
  /* Field: Transaction: State */
  $d_o['fields']['state']['id'] = 'state';
  $d_o['fields']['state']['table'] = 'mcapi_transactions';
  $d_o['fields']['state']['field'] = 'state';
  $d_o['fields']['state']['element_label_colon'] = FALSE;
  /* Field: Transaction: Type */
  $d_o['fields']['type']['id'] = 'type';
  $d_o['fields']['type']['table'] = 'mcapi_transactions';
  $d_o['fields']['type']['field'] = 'type';
  $d_o['fields']['type']['element_label_colon'] = FALSE;
  $d_o['path'] = 'transactions.csv';
  $d_o['displays'] = array(
    'page' => 'page',
    'default' => 0,
  );
  $d_o['use_batch'] = 'batch';

  /* Display: Exportation xls */
  $handler = $view->new_display('views_data_export', 'Exportation xls', 'views_data_export_2');
  $d_o = &$handler->display->display_options;
  $d_o['pager']['type'] = 'none';
  $d_o['pager']['options']['offset'] = '0';
  $d_o['style_plugin'] = 'views_data_export_xls';
  $d_o['style_options']['attach_text'] = 'Fichier.xls';
  $d_o['style_options']['provide_file'] = 1;
  $d_o['style_options']['filename'] = 'Echanges.xls';
  $d_o['style_options']['parent_sort'] = 0;
  $d_o['defaults']['fields'] = FALSE;
  /* Field: Transaction: Created */
  $d_o['fields']['created']['id'] = 'created';
  $d_o['fields']['created']['table'] = 'mcapi_transactions';
  $d_o['fields']['created']['field'] = 'created';
  $d_o['fields']['created']['label'] = 'Recorded';
  $d_o['fields']['created']['date_format'] = 'short';
  /* Field: Transaction: Serial */
  $d_o['fields']['serial']['id'] = 'serial';
  $d_o['fields']['serial']['table'] = 'mcapi_transactions';
  $d_o['fields']['serial']['field'] = 'serial';
  $d_o['fields']['serial']['exclude'] = TRUE;
  $d_o['fields']['serial']['element_label_colon'] = FALSE;
  $d_o['fields']['serial']['link_to_transaction'] = 0;
  /* Field: User: Name */
  $d_o['fields']['name_1']['id'] = 'name_1';
  $d_o['fields']['name_1']['table'] = 'users';
  $d_o['fields']['name_1']['field'] = 'name';
  $d_o['fields']['name_1']['relationship'] = 'payer';
  $d_o['fields']['name_1']['label'] = 'Payer';
  $d_o['fields']['name_1']['hide_alter_empty'] = FALSE;
  /* Field: User: Name */
  $d_o['fields']['name']['id'] = 'name';
  $d_o['fields']['name']['table'] = 'users';
  $d_o['fields']['name']['field'] = 'name';
  $d_o['fields']['name']['relationship'] = 'payee';
  $d_o['fields']['name']['label'] = 'Payee';
  $d_o['fields']['name']['hide_alter_empty'] = FALSE;
  /* Field: Transaction: Valeur */
  $d_o['fields']['worth']['id'] = 'worth';
  $d_o['fields']['worth']['table'] = 'field_data_worth';
  $d_o['fields']['worth']['field'] = 'worth';
  $d_o['fields']['worth']['element_default_classes'] = FALSE;
  $d_o['fields']['worth']['hide_alter_empty'] = FALSE;
  $d_o['fields']['worth']['click_sort_column'] = 'currcode';
  /* Field: Transaction: Description */
  $d_o['fields']['transaction_description']['id'] = 'transaction_description';
  $d_o['fields']['transaction_description']['table'] = 'field_data_transaction_description';
  $d_o['fields']['transaction_description']['field'] = 'transaction_description';
  $d_o['fields']['transaction_description']['label'] = '';
  $d_o['fields']['transaction_description']['alter']['make_link'] = TRUE;
  $d_o['fields']['transaction_description']['alter']['path'] = 'transaction/[serial]';
  $d_o['fields']['transaction_description']['element_label_colon'] = FALSE;
  $d_o['fields']['transaction_description']['type'] = 'text_plain';
  $d_o['fields']['transaction_description']['settings'] = array(
    'trim_length' => '600',
  );
  /* Field: Transaction: State */
  $d_o['fields']['state']['id'] = 'state';
  $d_o['fields']['state']['table'] = 'mcapi_transactions';
  $d_o['fields']['state']['field'] = 'state';
  $d_o['fields']['state']['element_label_colon'] = FALSE;
  /* Field: Transaction: Type */
  $d_o['fields']['type']['id'] = 'type';
  $d_o['fields']['type']['table'] = 'mcapi_transactions';
  $d_o['fields']['type']['field'] = 'type';
  $d_o['fields']['type']['element_label_colon'] = FALSE;
  $d_o['defaults']['filter_groups'] = FALSE;
  $d_o['defaults']['filters'] = FALSE;
  /* Filter criterion: Transaction: Type */
  $d_o['filters']['type']['id'] = 'type';
  $d_o['filters']['type']['table'] = 'mcapi_transactions';
  $d_o['filters']['type']['field'] = 'type';
  $d_o['filters']['type']['group'] = 0;
  $d_o['filters']['type']['exposed'] = TRUE;
  $d_o['filters']['type']['expose']['operator_id'] = 'type_op';
  $d_o['filters']['type']['expose']['label'] = 'Type';
  $d_o['filters']['type']['expose']['operator'] = 'type_op';
  $d_o['filters']['type']['expose']['identifier'] = 'type';
  $d_o['filters']['type']['expose']['multiple'] = TRUE;
  /* Filter criterion: User: Name */
  $d_o['filters']['uid']['id'] = 'uid';
  $d_o['filters']['uid']['table'] = 'users';
  $d_o['filters']['uid']['field'] = 'uid';
  $d_o['filters']['uid']['relationship'] = 'payee';
  $d_o['filters']['uid']['value'] = '';
  $d_o['filters']['uid']['group'] = 0;
  $d_o['filters']['uid']['exposed'] = TRUE;
  $d_o['filters']['uid']['expose']['operator_id'] = 'uid_op';
  $d_o['filters']['uid']['expose']['label'] = 'Payee';
  $d_o['filters']['uid']['expose']['operator'] = 'uid_op';
  $d_o['filters']['uid']['expose']['identifier'] = 'uid';
  /* Filter criterion: User: Name */
  $d_o['filters']['uid_1']['id'] = 'uid_1';
  $d_o['filters']['uid_1']['table'] = 'users';
  $d_o['filters']['uid_1']['field'] = 'uid';
  $d_o['filters']['uid_1']['relationship'] = 'payer';
  $d_o['filters']['uid_1']['value'] = '';
  $d_o['filters']['uid_1']['exposed'] = TRUE;
  $d_o['filters']['uid_1']['expose']['operator_id'] = 'uid_1_op';
  $d_o['filters']['uid_1']['expose']['label'] = 'Payer';
  $d_o['filters']['uid_1']['expose']['operator'] = 'uid_1_op';
  $d_o['filters']['uid_1']['expose']['identifier'] = 'uid_1';
  /* Filter criterion: Transaction: State */
  $d_o['filters']['state']['id'] = 'state';
  $d_o['filters']['state']['table'] = 'mcapi_transactions';
  $d_o['filters']['state']['field'] = 'state';
  $d_o['filters']['state']['value'] = array(
    1 => '1',
    0 => '0',
    -1 => '-1',
  );
  $d_o['filters']['state']['exposed'] = TRUE;
  $d_o['filters']['state']['expose']['operator_id'] = '';
  $d_o['filters']['state']['expose']['label'] = 'State';
  $d_o['filters']['state']['expose']['operator'] = 'state_op';
  $d_o['filters']['state']['expose']['identifier'] = 'state';
  $d_o['filters']['state']['expose']['remember_roles'] = array(
    2 => '2',
    1 => 0,
    4 => 0,
    6 => 0,
    7 => 0,
    3 => 0,
    8 => 0,
  );
  /* Filter criterion: Transaction: Valeur (worth:quantity) */
  $d_o['filters']['worth_quantity']['id'] = 'worth_quantity';
  $d_o['filters']['worth_quantity']['table'] = 'field_data_worth';
  $d_o['filters']['worth_quantity']['field'] = 'worth_quantity';
  $d_o['filters']['worth_quantity']['exposed'] = TRUE;
  $d_o['filters']['worth_quantity']['expose']['operator_id'] = 'worth_quantity_op';
  $d_o['filters']['worth_quantity']['expose']['label'] = 'Quantity';
  $d_o['filters']['worth_quantity']['expose']['use_operator'] = TRUE;
  $d_o['filters']['worth_quantity']['expose']['operator'] = 'worth_quantity_op';
  $d_o['filters']['worth_quantity']['expose']['identifier'] = 'worth_quantity';
  /* Filter criterion: Transaction: State */
  $d_o['filters']['state_1']['id'] = 'state_1';
  $d_o['filters']['state_1']['table'] = 'mcapi_transactions';
  $d_o['filters']['state_1']['field'] = 'state';
  $d_o['filters']['state_1']['value'] = array(
    1 => '1',
    0 => '0',
    -1 => '-1',
  );
  $d_o['path'] = 'echanges.xls';
  $d_o['displays'] = array(
    'page' => 'page',
    'default' => 0,
  );
  t('Transaction reports');
  t('All transactions can be seen from here. Use the filters to list what you need.');
  t('Report');
  t('Recorded');
  t('Quantity');
  t('Payer');
  t('Payee');

  $views[$view->name] = $view;


  $view = new view();
  $view->name = 'trade_analysis';
  $view->description = '';
  $view->tag = 'mcapi (index)';
  $view->base_table = 'mcapi_index';
  $view->human_name = 'Trading analysis';
  $view->core = 7;
  $view->api_version = '3.0';
  $view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */

  /* Display: Master */
  $handler = $view->new_display('default', 'Master', 'default');
  $d_o = &$handler->display->display_options;
  $d_o['use_more_always'] = FALSE;
  $d_o['use_more_text'] = 'plus';
  $d_o['group_by'] = TRUE;
  $d_o['access']['type'] = 'none';
  $d_o['cache']['type'] = 'none';
  $d_o['query']['type'] = 'views_query';
  $d_o['query']['options']['query_comment'] = FALSE;
  $d_o['exposed_form']['type'] = 'basic';
  $d_o['pager']['type'] = 'some';
  $d_o['pager']['options']['items_per_page'] = '1';
  $d_o['style_plugin'] = 'default';
  $d_o['row_plugin'] = 'fields';
  $d_o['row_options']['inline'] = array(
    'serial' => 'serial',
    'uid2' => 'uid2',
    'volume' => 'volume',
  );
  /* Champ: COUNT(DISTINCT Transaction index : Unique serial number) */
  $d_o['fields']['serial']['id'] = 'serial';
  $d_o['fields']['serial']['table'] = 'mcapi_index';
  $d_o['fields']['serial']['field'] = 'serial';
  $d_o['fields']['serial']['group_type'] = 'count_distinct';
  $d_o['fields']['serial']['label'] = 'Transactions';
  /* Champ: COUNT(DISTINCT Transaction index : 2nd user) */
  $d_o['fields']['uid2']['id'] = 'uid2';
  $d_o['fields']['uid2']['table'] = 'mcapi_index';
  $d_o['fields']['uid2']['field'] = 'uid2';
  $d_o['fields']['uid2']['group_type'] = 'count_distinct';
  $d_o['fields']['uid2']['label'] = 'Active traders';
  /* Champ: SUM(Transaction index : Volume d'échange ) */
  $d_o['fields']['volume']['id'] = 'volume';
  $d_o['fields']['volume']['table'] = 'mcapi_index';
  $d_o['fields']['volume']['field'] = 'volume';
  $d_o['fields']['volume']['group_type'] = 'sum';
  /* Champ: Transaction index : Greco index */
  $d_o['fields']['greco']['id'] = 'greco';
  $d_o['fields']['greco']['table'] = 'mcapi_index';
  $d_o['fields']['greco']['field'] = 'greco';
  $d_o['fields']['greco']['label'] = '';
  $d_o['fields']['greco']['alter']['alter_text'] = TRUE;
  $d_o['fields']['greco']['alter']['text'] = 'Greco index [greco]';
  $d_o['fields']['greco']['element_label_colon'] = FALSE;
  /* Critère de filtrage: Transaction index : Devise */
  $d_o['filters']['currcode']['id'] = 'currcode';
  $d_o['filters']['currcode']['table'] = 'mcapi_index';
  $d_o['filters']['currcode']['field'] = 'currcode';
  $d_o['filters']['currcode']['value'] = array(
    0 => 'credunit',
  );
  /* Critère de filtrage: Transaction index : Change in balance */
  $d_o['filters']['diff']['id'] = 'diff';
  $d_o['filters']['diff']['table'] = 'mcapi_index';
  $d_o['filters']['diff']['field'] = 'diff';
  $d_o['filters']['diff']['operator'] = '>';
  $d_o['filters']['diff']['value']['value'] = '0';

  /* Filter criterion: Date: Date (mcapi_index) */
  $d_o['filters']['date_filter']['id'] = 'date_filter';
  $d_o['filters']['date_filter']['table'] = 'mcapi_index';
  $d_o['filters']['date_filter']['field'] = 'date_filter';
  $d_o['filters']['date_filter']['operator'] = '>';
  $d_o['filters']['date_filter']['default_date'] = '-365 days';
  $d_o['filters']['date_filter']['year_range'] = '-3:+0';
  $d_o['filters']['date_filter']['date_fields'] = array(
    'mcapi_index.created' => 'mcapi_index.created',
  );

  /* Display: System trading stats */
  $handler = $view->new_display('block', 'System trading stats', 'system');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['hide_admin_links'] = FALSE;
  $d_o['defaults']['access'] = FALSE;
  $d_o['access']['type'] = 'curr';
  $d_o['access']['mode'] = 'system_data';
  $d_o['defaults']['fields'] = FALSE;
  /* Champ: COUNT(DISTINCT Transaction index : 2nd user) */
  $d_o['fields']['uid2']['id'] = 'uid2';
  $d_o['fields']['uid2']['table'] = 'mcapi_index';
  $d_o['fields']['uid2']['field'] = 'uid2';
  $d_o['fields']['uid2']['group_type'] = 'count_distinct';
  $d_o['fields']['uid2']['exclude'] = TRUE;
  $d_o['fields']['uid2']['element_label_colon'] = FALSE;
  $d_o['fields']['uid2']['prefix'] = ' ';
  /* Champ: COUNT(DISTINCT Transaction index : Unique serial number) */
  $d_o['fields']['serial']['id'] = 'serial';
  $d_o['fields']['serial']['table'] = 'mcapi_index';
  $d_o['fields']['serial']['field'] = 'serial';
  $d_o['fields']['serial']['group_type'] = 'count_distinct';
  $d_o['fields']['serial']['exclude'] = TRUE;
  $d_o['fields']['serial']['element_label_colon'] = FALSE;
  /* Field: SUM(Transaction index: Volume) */
  $d_o['fields']['volume']['id'] = 'volume';
  $d_o['fields']['volume']['table'] = 'mcapi_index';
  $d_o['fields']['volume']['field'] = 'volume';
  $d_o['fields']['volume']['group_type'] = 'sum';
  $d_o['fields']['volume']['alter']['alter_text'] = TRUE;
  $d_o['fields']['volume']['alter']['text'] = 'In the last year, our [uid2] active users have done [serial] transactions, totalling [volume]';
  $d_o['fields']['volume']['element_label_colon'] = FALSE;
  /* Field: Transaction index: Greco index */
  $d_o['fields']['greco']['id'] = 'greco';
  $d_o['fields']['greco']['table'] = 'mcapi_index';
  $d_o['fields']['greco']['field'] = 'greco';
  $d_o['fields']['greco']['label'] = "Thomas Greco's system health index";
  $d_o['fields']['greco']['alter']['text'] = ' : [greco]';
  $d_o['fields']['greco']['element_label_colon'] = FALSE;
  $d_o['block_description'] = 'Trading summary';

  /* Display: User trading stats */
  $handler = $view->new_display('block', 'User trading stats', 'user');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['hide_admin_links'] = FALSE;
  $d_o['defaults']['access'] = FALSE;
  $d_o['access']['type'] = 'curr';
  $d_o['access']['mode'] = 'trader_data';
  $d_o['defaults']['relationships'] = FALSE;
  /* Relation: Transaction index : 1st user */
  $d_o['relationships']['uid1']['id'] = 'uid1';
  $d_o['relationships']['uid1']['table'] = 'mcapi_index';
  $d_o['relationships']['uid1']['field'] = 'uid1';
  $d_o['defaults']['fields'] = FALSE;
  /* Champ: COUNT(DISTINCT Transaction index : Unique serial number) */
  $d_o['fields']['serial']['id'] = 'serial';
  $d_o['fields']['serial']['table'] = 'mcapi_index';
  $d_o['fields']['serial']['field'] = 'serial';
  $d_o['fields']['serial']['group_type'] = 'count_distinct';
  $d_o['fields']['serial']['label'] = 'Trades';
  /* Champ: COUNT(DISTINCT Transaction index : 2nd user) */
  $d_o['fields']['uid2']['id'] = 'uid2';
  $d_o['fields']['uid2']['table'] = 'mcapi_index';
  $d_o['fields']['uid2']['field'] = 'uid2';
  $d_o['fields']['uid2']['group_type'] = 'count_distinct';
  $d_o['fields']['uid2']['label'] = 'Promiscuity';
  /* Champ: SUM(Transaction index : Volume d'échange ) */
  $d_o['fields']['volume']['id'] = 'volume';
  $d_o['fields']['volume']['table'] = 'mcapi_index';
  $d_o['fields']['volume']['field'] = 'volume';
  $d_o['fields']['volume']['group_type'] = 'sum';
  $d_o['defaults']['arguments'] = FALSE;
  /* Filtre contextuel: Transaction index : 1st user */
  $d_o['arguments']['uid1']['id'] = 'uid1';
  $d_o['arguments']['uid1']['table'] = 'mcapi_index';
  $d_o['arguments']['uid1']['field'] = 'uid1';
  $d_o['arguments']['uid1']['exception']['title'] = 'Tout';
  $d_o['arguments']['uid1']['title_enable'] = TRUE;
  $d_o['arguments']['uid1']['title'] = '%1 summary';
  $d_o['arguments']['uid1']['default_argument_type'] = 'fixed';
  $d_o['arguments']['uid1']['summary']['number_of_records'] = '0';
  $d_o['arguments']['uid1']['summary']['format'] = 'default_summary';
  $d_o['arguments']['uid1']['summary_options']['items_per_page'] = '25';
  /* Filtre contextuel: Transaction index : Created moment */
  $d_o['arguments']['created']['id'] = 'created';
  $d_o['arguments']['created']['table'] = 'mcapi_index';
  $d_o['arguments']['created']['field'] = 'created';
  $d_o['arguments']['created']['exception']['title'] = 'All';
  $d_o['arguments']['created']['default_argument_type'] = 'fixed';
  $d_o['arguments']['created']['summary']['number_of_records'] = '0';
  $d_o['arguments']['created']['summary']['format'] = 'default_summary';
  $d_o['arguments']['created']['summary_options']['items_per_page'] = '25';
  $d_o['defaults']['filter_groups'] = FALSE;
  $d_o['defaults']['filters'] = FALSE;

  $translatables['trade_analysis'] = array(
    t('Active traders'),
    t("The [uid2] active users have made [serial] exchanges, totalling [volume]. Thomas Greco's system health index is: [greco]"),
  );
  $views[$view->name] = $view;





$view = new view();
$view->name = 'statement';
$view->description = 'shows trades of one user, with otheruser field and running balance. does not show dependent transactions';
$view->tag = 'mcapi (index)';
$view->base_table = 'mcapi_index';
$view->human_name = 'Statement';
$view->core = 7;
$view->api_version = '3.0';
$view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */

/* Display: Master */
$handler = $view->new_display('default', 'Master', 'default');
  $d_o = &$handler->display->display_options;
$d_o['title'] = 'Statement';
$d_o['use_more_always'] = FALSE;
$d_o['access']['type'] = 'arg1user';
$d_o['cache']['type'] = 'none';
$d_o['query']['type'] = 'views_query';
$d_o['query']['options']['query_comment'] = FALSE;
$d_o['exposed_form']['type'] = 'basic';
$d_o['pager']['type'] = 'date_views_pager';
$d_o['pager']['options']['pager_position'] = 'bottom';
$d_o['style_plugin'] = 'table';
/* No results behavior: Global: Text area */
$d_o['empty']['area']['id'] = 'area';
$d_o['empty']['area']['table'] = 'views';
$d_o['empty']['area']['field'] = 'area';
$d_o['empty']['area']['label'] = 'empty text';
$d_o['empty']['area']['empty'] = TRUE;
$d_o['empty']['area']['content'] = 'No transactions';
$d_o['empty']['area']['format'] = 'plain_text';
/* Relationship: Transaction index: 2nd user */
$d_o['relationships']['uid2']['id'] = 'uid2';
$d_o['relationships']['uid2']['table'] = 'mcapi_index';
$d_o['relationships']['uid2']['field'] = 'uid2';
$d_o['relationships']['uid2']['required'] = TRUE;
/* Field: Transaction index: Unique serial number */
$d_o['fields']['serial']['id'] = 'serial';
$d_o['fields']['serial']['table'] = 'mcapi_index';
$d_o['fields']['serial']['field'] = 'serial';
$d_o['fields']['serial']['label'] = '';
$d_o['fields']['serial']['exclude'] = TRUE;
$d_o['fields']['serial']['element_label_colon'] = FALSE;
$d_o['fields']['serial']['link_to_transaction'] = 0;
/* Field: Transaction index: Created moment */
$d_o['fields']['created']['id'] = 'created';
$d_o['fields']['created']['table'] = 'mcapi_index';
$d_o['fields']['created']['field'] = 'created';
$d_o['fields']['created']['label'] = 'Activity date';
$d_o['fields']['created']['hide_alter_empty'] = FALSE;
$d_o['fields']['created']['date_format'] = 'custom';
$d_o['fields']['created']['custom_date_format'] = 'd M Y';
$d_o['fields']['created']['second_date_format'] = 'long';
/* Field: User: Name */
$d_o['fields']['name']['id'] = 'name';
$d_o['fields']['name']['table'] = 'users';
$d_o['fields']['name']['field'] = 'name';
$d_o['fields']['name']['relationship'] = 'uid2';
$d_o['fields']['name']['label'] = 'With';
$d_o['fields']['name']['hide_alter_empty'] = FALSE;
/* Field: Transaction: Description */
$d_o['fields']['transaction_description']['id'] = 'transaction_description';
$d_o['fields']['transaction_description']['table'] = 'field_data_transaction_description';
$d_o['fields']['transaction_description']['field'] = 'transaction_description';
$d_o['fields']['transaction_description']['alter']['make_link'] = TRUE;
$d_o['fields']['transaction_description']['alter']['path'] = 'transaction/[serial]';
/* Field: Transaction index: Income */
$d_o['fields']['income']['id'] = 'income';
$d_o['fields']['income']['table'] = 'mcapi_index';
$d_o['fields']['income']['field'] = 'income';
$d_o['fields']['income']['label'] = 'Given';
$d_o['fields']['income']['hide_empty'] = TRUE;
/* Field: Transaction index: Expenditure */
$d_o['fields']['expenditure']['id'] = 'expenditure';
$d_o['fields']['expenditure']['table'] = 'mcapi_index';
$d_o['fields']['expenditure']['field'] = 'expenditure';
$d_o['fields']['expenditure']['label'] = 'Received';
$d_o['fields']['expenditure']['hide_empty'] = TRUE;
/* Field: Transaction index: Balance */
$d_o['fields']['balance']['id'] = 'balance';
$d_o['fields']['balance']['table'] = 'mcapi_index';
$d_o['fields']['balance']['field'] = 'balance';
$d_o['fields']['balance']['hide_alter_empty'] = FALSE;
/* Field: Transaction index: Operations */
$d_o['fields']['operations']['id'] = 'operations';
$d_o['fields']['operations']['table'] = 'mcapi_index';
$d_o['fields']['operations']['field'] = 'operations';
$d_o['fields']['operations']['link_to_transaction'] = 0;
/* Sort criterion: Transaction index: Created moment */
$d_o['sorts']['created']['id'] = 'created';
$d_o['sorts']['created']['table'] = 'mcapi_index';
$d_o['sorts']['created']['field'] = 'created';
$d_o['sorts']['created']['order'] = 'DESC';
/* Contextual filter: Transaction index: 1st user */
$d_o['arguments']['uid1']['id'] = 'uid1';
$d_o['arguments']['uid1']['table'] = 'mcapi_index';
$d_o['arguments']['uid1']['field'] = 'uid1';
$d_o['arguments']['uid1']['default_action'] = 'default';
$d_o['arguments']['uid1']['default_argument_type'] = 'user';
$d_o['arguments']['uid1']['default_argument_options']['user'] = FALSE;
$d_o['arguments']['uid1']['summary']['number_of_records'] = '0';
$d_o['arguments']['uid1']['summary']['format'] = 'default_summary';
$d_o['arguments']['uid1']['summary_options']['items_per_page'] = '25';
/* Contextual filter: Date: Date (mcapi_index) */
$d_o['arguments']['date_argument']['id'] = 'date_argument';
$d_o['arguments']['date_argument']['table'] = 'mcapi_index';
$d_o['arguments']['date_argument']['field'] = 'date_argument';
$d_o['arguments']['date_argument']['default_action'] = 'default';
$d_o['arguments']['date_argument']['default_argument_type'] = 'date';
$d_o['arguments']['date_argument']['summary']['format'] = 'default_summary';
$d_o['arguments']['date_argument']['year_range'] = '-10:+0';
$d_o['arguments']['date_argument']['granularity'] = 'year';
$d_o['arguments']['date_argument']['use_fromto'] = 'no';
$d_o['arguments']['date_argument']['date_fields'] = array(
  'mcapi_index.created' => 'mcapi_index.created',
);

/* Display: Statement */
$handler = $view->new_display('page', 'Statement', 'page');
  $d_o = &$handler->display->display_options;
$d_o['path'] = 'user/%/statement';
$d_o['menu']['type'] = 'tab';
$d_o['menu']['title'] = 'Statement';
$d_o['menu']['weight'] = '10';
$d_o['menu']['context'] = 0;
$d_o['menu']['context_only_inline'] = 0;

/* Display: Embed */
$handler = $view->new_display('embed', 'Embed', 'embed');
  $d_o = &$handler->display->display_options;
$d_o['defaults']['pager'] = FALSE;
$d_o['pager']['type'] = 'some';
$d_o['pager']['options']['items_per_page'] = '5';
$d_o['pager']['options']['offset'] = '0';
$d_o['defaults']['arguments'] = FALSE;
/* Contextual filter: Transaction index: 1st user */
$d_o['arguments']['uid1']['id'] = 'uid1';
$d_o['arguments']['uid1']['table'] = 'mcapi_index';
$d_o['arguments']['uid1']['field'] = 'uid1';
$d_o['arguments']['uid1']['default_action'] = 'default';
$d_o['arguments']['uid1']['default_argument_type'] = 'user';
$d_o['arguments']['uid1']['default_argument_options']['user'] = FALSE;
$d_o['arguments']['uid1']['summary']['number_of_records'] = '0';
$d_o['arguments']['uid1']['summary']['format'] = 'default_summary';
$d_o['arguments']['uid1']['summary_options']['items_per_page'] = '25';

  $views[$view->name] = $view;

  t('Activity date');
  t('Given');
  t('Received');
  t('Description');
  t('Actions');
}
