<?php

/**
 * Implementation of hook views_default_views().
 */
function cforge_yell_views_default_views() {
  $view = yell_directory_view(0);
  $views[$view->name] = $view;
  if (variable_get('offers_wants_proposition_wants', TRUE)) {
    $view = yell_directory_view(1);
    $views[$view->name] = $view;
  }
  return $views;
}


function yell_directory_view($want) {
  $view = new view();
  $view->name = $want ? 'ow_wants' : 'ow_offers';
  $view->description = $want ? t('Directory of wants') : t('Directory of offers');
  $view->description .= ' ('. t('Default view is autogenerated') . ')';
  $view->tag = 'offers_wants';
  $view->base_table = 'node';
  $view->human_name = $want ? 'Auto wants view' : 'Auto offers view';
  $view->core = 0;
  $view->api_version = '3.0';
  $view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */

  /* Display: Defaults */
  $handler = $view->new_display('default', 'Defaults', 'default');
  $d_o = &$handler->display->display_options;
  $d_o['title'] = $want ? t('Wants') : t('Offers');
  $d_o['use_more'] = FALSE;
  $d_o['use_more_always'] = FALSE;
  $d_o['use_more_text'] = '';
  $d_o['access']['type'] = 'perm';
  $d_o['cache']['type'] = 'none';
  $d_o['query']['type'] = 'views_query';
  $d_o['query']['options']['disable_sql_rewrite'] = TRUE;
  $d_o['query']['options']['distinct'] = TRUE;
  $d_o['query']['options']['query_comment'] = FALSE;
  $d_o['exposed_form']['type'] = 'basic';
  $d_o['exposed_form']['options']['submit_button'] = 'Appliquer';
  $d_o['exposed_form']['options']['reset_button_label'] = 'Réinitialiser';
  $d_o['exposed_form']['options']['exposed_sorts_label'] = 'Trier par';
  $d_o['pager']['type'] = 'full';
  $d_o['pager']['options']['items_per_page'] = '25';
  $d_o['pager']['options']['offset'] = '0';
  $d_o['pager']['options']['id'] = '0';
  $d_o['pager']['options']['expose']['items_per_page_label'] = 'Éléments par page';
  $d_o['pager']['options']['expose']['items_per_page_options_all_label'] = '- Tout -';
  $d_o['pager']['options']['expose']['offset_label'] = 'Décalage';
  $d_o['pager']['options']['tags']['first'] = '« premier';
  $d_o['pager']['options']['tags']['previous'] = ' précédent';
  $d_o['pager']['options']['tags']['next'] = 'suivant ';
  $d_o['pager']['options']['tags']['last'] = 'dernier »';
  $d_o['style_plugin'] = 'table';
  $d_o['style_options']['columns'] = array(
    'image' => 'image',
    'title' => 'title',
    'body' => 'body',
    'name' => 'name',
    'picture' => 'picture',
    'profile_address_dependent_locality' => 'profile_address_dependent_locality',
    'end' => 'end',
  );
  $d_o['style_options']['default'] = '-1';
  $d_o['style_options']['info'] = array(
    'image' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 1,
    ),
    'title' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'body' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'name' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'picture' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 1,
    ),
    'profile_address_dependent_locality' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'end' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
  );

  /* Footer: Global: Text area */
  $d_o['footer']['area']['id'] = 'area';
  $d_o['footer']['area']['table'] = 'views';
  $d_o['footer']['area']['field'] = 'area';
  $d_o['footer']['area']['label'] = 'GDPR';
  $d_o['footer']['area']['content'] = t('This data should only be shared with members of @site_name', array('@site_name' => variable_get('site_name')));
  $d_o['footer']['area']['format'] = 'editor_filtered_html';
  /* No results behavior: Global: Text area */
  $d_o['empty']['text']['id'] = 'area';
  $d_o['empty']['text']['table'] = 'views';
  $d_o['empty']['text']['field'] = 'area';
  $d_o['empty']['text']['content'] = $want ? 'No wants have been entered.' : 'No offers have been entered.';
  $d_o['empty']['text']['format'] = 'plain_text';
  /* Relationship: Content: Author */
  $d_o['relationships']['uid']['id'] = 'uid';
  $d_o['relationships']['uid']['table'] = 'node';
  $d_o['relationships']['uid']['field'] = 'uid';
  /* Relationship: Content: Types d&#039;offres/demandes (offers_wants_types) */
  $d_o['relationships']['offers_wants_types_tid']['id'] = 'offers_wants_types_tid';
  $d_o['relationships']['offers_wants_types_tid']['table'] = 'field_data_offers_wants_types';
  $d_o['relationships']['offers_wants_types_tid']['field'] = 'offers_wants_types_tid';
  /* Relationship: Field: Catégories d&#039;offres et de demandes (offers_wants_categories) */
  $d_o['relationships']['offers_wants_categories_tid_1']['id'] = 'offers_wants_categories_tid_1';
  $d_o['relationships']['offers_wants_categories_tid_1']['table'] = 'field_data_offers_wants_categories';
  $d_o['relationships']['offers_wants_categories_tid_1']['field'] = 'offers_wants_categories_tid';
  /* Field: Content: Image */
  $d_o['fields']['image']['id'] = 'image';
  $d_o['fields']['image']['table'] = 'field_data_image';
  $d_o['fields']['image']['field'] = 'image';
  $d_o['fields']['image']['click_sort_column'] = 'fid';
  $d_o['fields']['image']['settings'] = array(
    'image_style' => 'thumbnail',
    'image_link' => '',
  );
  /* Field: Content: Title */
  $d_o['fields']['title']['id'] = 'title';
  $d_o['fields']['title']['table'] = 'node';
  $d_o['fields']['title']['field'] = 'title';
  $d_o['fields']['title']['label'] = 'Description';
  /* Field: Content: Corps */
  $d_o['fields']['body']['id'] = 'body';
  $d_o['fields']['body']['table'] = 'field_data_body';
  $d_o['fields']['body']['field'] = 'body';
  $d_o['fields']['body']['label'] = '';
  $d_o['fields']['body']['type'] = 'text_summary_or_trimmed';
  $d_o['fields']['body']['settings'] = array(
    'trim_length' => '600',
  );
  /* Field: Propositions: Expiry date */
  $d_o['fields']['end']['id'] = 'end';
  $d_o['fields']['end']['table'] = 'offers_wants';
  $d_o['fields']['end']['field'] = 'end';
  $d_o['fields']['end']['label'] = 'Expires on';
  $d_o['fields']['end']['date_format'] = 'short';
  /* Field: User: Name */
  $d_o['fields']['name']['id'] = 'name';
  $d_o['fields']['name']['table'] = 'users';
  $d_o['fields']['name']['field'] = 'name';
  $d_o['fields']['name']['relationship'] = 'uid';
  $d_o['fields']['name']['label'] = 'Member';
  /* Field: User: Picture */
  $d_o['fields']['picture']['id'] = 'picture';
  $d_o['fields']['picture']['table'] = 'users';
  $d_o['fields']['picture']['field'] = 'picture';
  $d_o['fields']['picture']['relationship'] = 'uid';
  $d_o['fields']['picture']['label'] = '';
  $d_o['fields']['picture']['image_style'] = 'thumbnail';
  /* Field: User: Neighbourhood */
  $d_o['fields']['profile_address_dependent_locality']['id'] = 'profile_address_dependent_locality';
  $d_o['fields']['profile_address_dependent_locality']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_dependent_locality']['field'] = 'profile_address_dependent_locality';
  $d_o['fields']['profile_address_dependent_locality']['relationship'] = 'uid';
  /* Sort criterion: Content: Updated date */
  $d_o['sorts']['changed']['id'] = 'changed';
  $d_o['sorts']['changed']['table'] = 'node';
  $d_o['sorts']['changed']['field'] = 'changed';
  $d_o['sorts']['changed']['order'] = 'DESC';
  $d_o['sorts']['changed']['granularity'] = 'hour';
  /* Contextual filter: Content: Has taxonomy term ID (with depth) */
  $d_o['arguments']['term_node_tid_depth']['id'] = 'term_node_tid_depth';
  $d_o['arguments']['term_node_tid_depth']['table'] = 'node';
  $d_o['arguments']['term_node_tid_depth']['field'] = 'term_node_tid_depth';
  $d_o['arguments']['term_node_tid_depth']['exception']['title'] = 'Tout';
  $d_o['arguments']['term_node_tid_depth']['title_enable'] = TRUE;
  $d_o['arguments']['term_node_tid_depth']['title'] = $want ? t('Wants'). ' %1' : t('Offers'). '%1';
  $d_o['arguments']['term_node_tid_depth']['default_argument_type'] = 'fixed';
  $d_o['arguments']['term_node_tid_depth']['summary']['number_of_records'] = '0';
  $d_o['arguments']['term_node_tid_depth']['summary']['format'] = 'default_summary';
  $d_o['arguments']['term_node_tid_depth']['summary_options']['items_per_page'] = '25';
  $d_o['arguments']['term_node_tid_depth']['depth'] = '1';
  /* Contextual filter: Taxonomy term: Term ID */
  $d_o['arguments']['tid']['id'] = 'tid';
  $d_o['arguments']['tid']['table'] = 'taxonomy_term_data';
  $d_o['arguments']['tid']['field'] = 'tid';
  $d_o['arguments']['tid']['relationship'] = 'offers_wants_types_tid';
  $d_o['arguments']['tid']['exception']['title'] = 'All';
  $d_o['arguments']['tid']['default_argument_type'] = 'fixed';
  $d_o['arguments']['tid']['summary']['number_of_records'] = '0';
  $d_o['arguments']['tid']['summary']['format'] = 'default_summary';
  $d_o['arguments']['tid']['summary_options']['items_per_page'] = '25';
  $d_o['arguments']['tid']['specify_validation'] = TRUE;
  $d_o['arguments']['tid']['validate']['type'] = 'taxonomy_term';
  $d_o['arguments']['tid']['validate_options']['vocabularies'] = array(
    'offers_wants_types' => 'offers_wants_types',
  );
  /* Filter criterion: Content: Type */
  $d_o['filters']['type']['id'] = 'type';
  $d_o['filters']['type']['table'] = 'node';
  $d_o['filters']['type']['field'] = 'type';
  $d_o['filters']['type']['value'] = array(
    'proposition' => 'proposition',
  );
  $d_o['filters']['type']['group'] = 1;
  $d_o['filters']['type']['expose']['operator'] = FALSE;
  /* Filter criterion: Propositions: Is a want */
  $d_o['filters']['want']['id'] = 'want';
  $d_o['filters']['want']['table'] = 'offers_wants';
  $d_o['filters']['want']['field'] = 'want';
  $d_o['filters']['want']['value'] = $want;
  $d_o['filters']['want']['group'] = 1;
  /* Filter criterion: User: Active */
  $d_o['filters']['status']['id'] = 'status';
  $d_o['filters']['status']['table'] = 'users';
  $d_o['filters']['status']['field'] = 'status';
  $d_o['filters']['status']['relationship'] = 'uid';
  $d_o['filters']['status']['value'] = '1';
  $d_o['filters']['status']['group'] = 1;
  $d_o['filters']['status']['expose']['operator'] = FALSE;
  /* Filter criterion: Content: Published or admin */
  $d_o['filters']['status_extra']['id'] = 'status_extra';
  $d_o['filters']['status_extra']['table'] = 'node';
  $d_o['filters']['status_extra']['field'] = 'status_extra';
  $d_o['filters']['status_extra']['group'] = 1;

  /* Display: All */
  $handler = $view->new_display('page', 'All', 'all');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['title'] = FALSE;
  $d_o['title'] = $want ? 'Wants' : 'Offers';
  $d_o['defaults']['hide_admin_links'] = FALSE;
  $d_o['defaults']['style_plugin'] = FALSE;
  $d_o['style_plugin'] = 'table';
  $d_o['style_options']['columns'] = array(
    'image' => 'image',
    'title' => 'title',
    'name' => 'name',
    'offers_wants_categories' => 'offers_wants_categories',
    'end' => 'end',
    'profile_address_dependent_locality_1' => 'profile_address_dependent_locality_1',
    'status' => 'status',
  );
  $d_o['style_options']['default'] = '-1';
  $d_o['style_options']['info'] = array(
    'image' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 1,
    ),
    'title' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'name' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'offers_wants_categories' => array(
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'end' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'profile_address_dependent_locality_1' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'status' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
  );
  $d_o['defaults']['style_options'] = FALSE;
  $d_o['defaults']['row_plugin'] = FALSE;
  $d_o['defaults']['row_options'] = FALSE;
  $d_o['defaults']['fields'] = FALSE;
  /* Field: Content: Image */
  $d_o['fields']['image']['id'] = 'image';
  $d_o['fields']['image']['table'] = 'field_data_image';
  $d_o['fields']['image']['field'] = 'image';
  $d_o['fields']['image']['click_sort_column'] = 'fid';
  $d_o['fields']['image']['settings'] = array(
    'image_style' => 'thumbnail',
    'image_link' => '',
  );
  /* Field: Content: Title */
  $d_o['fields']['title']['id'] = 'title';
  $d_o['fields']['title']['table'] = 'node';
  $d_o['fields']['title']['field'] = 'title';
  $d_o['fields']['title']['label'] = 'Description';
  $d_o['fields']['title']['element_label_colon'] = FALSE;
  /* Field: Field: Catégories d'offres et de demandes */
  $d_o['fields']['offers_wants_categories']['id'] = 'offers_wants_categories';
  $d_o['fields']['offers_wants_categories']['table'] = 'field_data_offers_wants_categories';
  $d_o['fields']['offers_wants_categories']['field'] = 'offers_wants_categories';
  $d_o['fields']['offers_wants_categories']['label'] = 'Categories';
  $d_o['fields']['offers_wants_categories']['delta_offset'] = '0';
  /* Field: Propositions: Expiry date */
  $d_o['fields']['end']['id'] = 'end';
  $d_o['fields']['end']['table'] = 'offers_wants';
  $d_o['fields']['end']['field'] = 'end';
  $d_o['fields']['end']['label'] = 'Expires on';
  $d_o['fields']['end']['date_format'] = 'short';
  /* Field: User: Name */
  $d_o['fields']['name']['id'] = 'name';
  $d_o['fields']['name']['table'] = 'users';
  $d_o['fields']['name']['field'] = 'name';
  $d_o['fields']['name']['relationship'] = 'uid';
  $d_o['fields']['name']['label'] = 'Member';
  $d_o['fields']['name']['element_label_colon'] = FALSE;
  /* Field: User: Neighbourhood */
  $d_o['fields']['profile_address_dependent_locality_1']['id'] = 'profile_address_dependent_locality_1';
  $d_o['fields']['profile_address_dependent_locality_1']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_dependent_locality_1']['field'] = 'profile_address_dependent_locality';
  $d_o['fields']['profile_address_dependent_locality_1']['relationship'] = 'uid';
  /* Field: Content: Published */
  $d_o['fields']['status']['id'] = 'status';
  $d_o['fields']['status']['table'] = 'node';
  $d_o['fields']['status']['field'] = 'status';
  $d_o['fields']['status']['type'] = 'unicode-yes-no';
  $d_o['fields']['status']['not'] = 0;
  $d_o['path'] = $want ? 'wants/all' : 'offers/all';
  $d_o['menu']['type'] = 'default tab';
  $d_o['menu']['title'] = 'All';
  $d_o['menu']['weight'] = '0';
  $d_o['tab_options']['type'] = 'normal';
  $d_o['tab_options']['title'] = $want ? 'Wants' : 'Offers';
  $d_o['tab_options']['weight'] = 1;
  $d_o['tab_options']['name'] = 'main-menu';

  /* Display: latest offers/wants */
  $handler = $view->new_display('block', $want ? t('Latest wants') : t('Latest offers'), 'latest');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['title'] = FALSE;
  $d_o['title'] = $want ? t('Latest wants') : t('Latest offers');
  $d_o['defaults']['use_more'] = FALSE;
  $d_o['use_more'] = TRUE;
  $d_o['defaults']['pager'] = FALSE;
  $d_o['pager']['type'] = 'some';
  $d_o['pager']['options']['items_per_page'] = '5';
  $d_o['pager']['options']['offset'] = '0';
  $d_o['defaults']['style_plugin'] = FALSE;
  $d_o['style_plugin'] = 'list';
  $d_o['defaults']['style_options'] = FALSE;
  $d_o['defaults']['row_plugin'] = FALSE;
  $d_o['row_plugin'] = 'fields';
  $d_o['row_options']['inline'] = array(
    'title' => 'title',
    'name' => 'name',
  );
  $d_o['defaults']['row_options'] = FALSE;
  $d_o['defaults']['fields'] = FALSE;
  /* Field: Content: Title */
  $d_o['fields']['title']['id'] = 'title';
  $d_o['fields']['title']['table'] = 'node';
  $d_o['fields']['title']['field'] = 'title';
  $d_o['fields']['title']['label'] = '';
  $d_o['fields']['title']['element_label_colon'] = FALSE;
  $d_o['fields']['title']['hide_alter_empty'] = FALSE;
  /* Field: User: Name */
  $d_o['fields']['name']['id'] = 'name';
  $d_o['fields']['name']['table'] = 'users';
  $d_o['fields']['name']['field'] = 'name';
  $d_o['fields']['name']['relationship'] = 'uid';
  $d_o['fields']['name']['label'] = '';
  $d_o['fields']['name']['alter']['alter_text'] = TRUE;
  $d_o['fields']['name']['alter']['text'] = '- [name]';
  $d_o['fields']['name']['element_label_colon'] = FALSE;
  $d_o['fields']['name']['hide_alter_empty'] = FALSE;
  $d_o['block_description'] = $want ? t('Latest wants') : t('Latest offers');

  if ($want) {
    /* Display: Urgent wants */
    $handler = $view->new_display('block', t('Urgent wants'), 'urgent');
    $d_o = &$handler->display->display_options;
    $d_o['defaults']['title'] = FALSE;
    $d_o['title'] = t('Urgent wants');
    $d_o['defaults']['hide_admin_links'] = FALSE;
    $d_o['defaults']['use_more'] = FALSE;
    $d_o['use_more'] = TRUE;
    $d_o['defaults']['pager'] = FALSE;
    $d_o['pager']['type'] = 'some';
    $d_o['pager']['options']['items_per_page'] = '5';
    $d_o['pager']['options']['offset'] = '0';
    $d_o['defaults']['style_plugin'] = FALSE;
    $d_o['style_plugin'] = 'list';
    $d_o['defaults']['style_options'] = FALSE;
    $d_o['defaults']['row_plugin'] = FALSE;
    $d_o['row_plugin'] = 'fields';
    $d_o['row_options']['inline'] = array(
      'title' => 'title',
      'name' => 'name',
      'end' => 'end',
    );
    $d_o['defaults']['row_options'] = FALSE;
    $d_o['defaults']['empty'] = FALSE;
    $d_o['defaults']['fields'] = FALSE;
    /* Champ: Contenu : Titre */
    $d_o['fields']['title']['id'] = 'title';
    $d_o['fields']['title']['table'] = 'node';
    $d_o['fields']['title']['field'] = 'title';
    $d_o['fields']['title']['label'] = '';
    $d_o['fields']['title']['exclude'] = TRUE;
    $d_o['fields']['title']['element_label_colon'] = FALSE;
    $d_o['fields']['title']['hide_alter_empty'] = FALSE;
    /* Champ: Utilisateur : Nom */
    $d_o['fields']['name']['id'] = 'name';
    $d_o['fields']['name']['table'] = 'users';
    $d_o['fields']['name']['field'] = 'name';
    $d_o['fields']['name']['relationship'] = 'uid';
    $d_o['fields']['name']['label'] = '';
    $d_o['fields']['name']['exclude'] = TRUE;
    $d_o['fields']['name']['alter']['alter_text'] = TRUE;
    $d_o['fields']['name']['alter']['text'] = '- [name]';
    $d_o['fields']['name']['element_label_colon'] = FALSE;
    $d_o['fields']['name']['hide_alter_empty'] = FALSE;
    /* Champ: Annonces : Date d'expiration */
    $d_o['fields']['end']['id'] = 'end';
    $d_o['fields']['end']['table'] = 'offers_wants';
    $d_o['fields']['end']['field'] = 'end';
    $d_o['fields']['end']['label'] = '';
    $d_o['fields']['end']['alter']['alter_text'] = TRUE;
    $d_o['fields']['end']['alter']['text'] = '[name] needs [title] before [end]';
    $d_o['fields']['end']['element_label_colon'] = FALSE;
    $d_o['fields']['end']['date_format'] = 'raw time hence';
    $d_o['defaults']['sorts'] = FALSE;
    /* Critère de tri: Annonces : Date d'expiration */
    $d_o['sorts']['end']['id'] = 'end';
    $d_o['sorts']['end']['table'] = 'offers_wants';
    $d_o['sorts']['end']['field'] = 'end';
    $d_o['defaults']['filter_groups'] = FALSE;
    $d_o['defaults']['filters'] = FALSE;
    /* Critère de filtrage: Contenu : Type */
    $d_o['filters']['type']['id'] = 'type';
    $d_o['filters']['type']['table'] = 'node';
    $d_o['filters']['type']['field'] = 'type';
    $d_o['filters']['type']['value'] = array(
      'proposition' => 'proposition',
    );
    $d_o['filters']['type']['group'] = 1;
    /* Critère de filtrage: Annonces : Date d'expiration */
    $d_o['filters']['end']['id'] = 'end';
    $d_o['filters']['end']['table'] = 'offers_wants';
    $d_o['filters']['end']['field'] = 'end';
    $d_o['filters']['end']['operator'] = '>';
    $d_o['filters']['end']['value']['value'] = '-1 day';
    $d_o['filters']['end']['value']['type'] = 'offset';
    $d_o['filters']['end']['group'] = 1;
    /* Critère de filtrage: Annonces : Est une demande */
    $d_o['filters']['want']['id'] = 'want';
    $d_o['filters']['want']['table'] = 'offers_wants';
    $d_o['filters']['want']['field'] = 'want';
    $d_o['filters']['want']['value'] = '1';
    $d_o['filters']['want']['group'] = 1;
    /* Critère de filtrage: Utilisateur : Actif */
    $d_o['filters']['status']['id'] = 'status';
    $d_o['filters']['status']['table'] = 'users';
    $d_o['filters']['status']['field'] = 'status';
    $d_o['filters']['status']['relationship'] = 'uid';
    $d_o['filters']['status']['value'] = '1';
    $d_o['filters']['status']['group'] = 1;
    /* Critère de filtrage: Date : Date (node) */
    $d_o['filters']['date_filter']['id'] = 'date_filter';
    $d_o['filters']['date_filter']['table'] = 'node';
    $d_o['filters']['date_filter']['field'] = 'date_filter';
    $d_o['filters']['date_filter']['operator'] = 'between';
    $d_o['filters']['date_filter']['default_date'] = '-5 weeks';
    $d_o['filters']['date_filter']['default_to_date'] = 'now';
    $d_o['filters']['date_filter']['year_range'] = '-1:+1';
    $d_o['filters']['date_filter']['date_fields'] = array(
      'node.created' => 'node.created',
    );
    $d_o['filters']['date_filter']['date_method'] = 'AND';
    /* Critère de filtrage: Date : Date (node) */
    $d_o['filters']['date_filter_1']['id'] = 'date_filter_1';
    $d_o['filters']['date_filter_1']['table'] = 'node';
    $d_o['filters']['date_filter_1']['field'] = 'date_filter';
    $d_o['filters']['date_filter_1']['operator'] = '<';
    $d_o['filters']['date_filter_1']['default_date'] = '+5 weeks';
    $d_o['filters']['date_filter_1']['year_range'] = '-1:+1';
    $d_o['filters']['date_filter_1']['date_fields'] = array(
      'offers_wants.end' => 'offers_wants.end',
    );
    $d_o['filters']['date_filter_1']['date_method'] = 'AND';
    $d_o['block_description'] = t('Urgent wants');
  }

  /* Display: Export to CSV */
  $csv_filename = ($want ? t('wants')  : t('offers')).'.csv';
  $handler = $view->new_display('views_data_export', 'Export to CSV', 'views_data_export_1');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['hide_admin_links'] = FALSE;
  $d_o['defaults']['access'] = FALSE;
  $d_o['access']['type'] = 'perm';
  $d_o['access']['perm'] = 'edit propositions';
  $d_o['pager']['type'] = 'none';
  $d_o['pager']['options']['offset'] = '0';
  $d_o['style_plugin'] = 'views_data_export_csv';
  $d_o['style_options']['provide_file'] = 1;
  $d_o['style_options']['filename'] = $csv_filename;
  $d_o['style_options']['parent_sort'] = 0;
  $d_o['style_options']['quote'] = 1;
  $d_o['style_options']['trim'] = 0;
  $d_o['style_options']['replace_newlines'] = 1;
  $d_o['style_options']['newline_replacement'] = '\\n';
  $d_o['style_options']['header'] = 1;
  $d_o['path'] = $csv_filename;
  $d_o['displays'] = array(
    'all' => 'all',
  );
  $d_o['use_batch'] = 'batch';

  /* Display: print-table */
  $handler = $view->new_display('print-table', 'print-table', 'print-table_1');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['access'] = FALSE;
  $d_o['access']['type'] = 'role';
  $d_o['access']['role'] = array(RID_COMMITTEE => RID_COMMITTEE);
  $d_o['pager']['type'] = 'none';
  $d_o['defaults']['style_plugin'] = FALSE;
  $d_o['style_plugin'] = 'table';
  $d_o['style_options']['grouping'] = array(
    0 => array(
      'field' => 'name_1',
      'rendered' => 1,
      'rendered_strip' => 0,
    ),
  );
  $d_o['style_options']['columns'] = array(
    'name_1' => 'name_1',
    'title' => 'title',
    'name' => 'name',
    'offers_wants_types' => 'offers_wants_types',
  );
  $d_o['style_options']['default'] = 'name_1';
  $d_o['style_options']['info'] = array(
    'name_1' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'title' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'name' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'offers_wants_types' => array(
      'align' => '',
      'separator' => '',
      'empty_column' => 1,
    ),
  );
  $d_o['defaults']['style_options'] = FALSE;
  $d_o['defaults']['row_plugin'] = FALSE;
  $d_o['defaults']['row_options'] = FALSE;
  $d_o['defaults']['relationships'] = FALSE;
  /* Relationship: Content: Author */
  $d_o['relationships']['uid']['id'] = 'uid';
  $d_o['relationships']['uid']['table'] = 'node';
  $d_o['relationships']['uid']['field'] = 'uid';
  /* Relationship: Field: Catégories d&#039;offres et de demandes (offers_wants_categories) */
  $d_o['relationships']['offers_wants_categories_tid']['id'] = 'offers_wants_categories_tid';
  $d_o['relationships']['offers_wants_categories_tid']['table'] = 'field_data_offers_wants_categories';
  $d_o['relationships']['offers_wants_categories_tid']['field'] = 'offers_wants_categories_tid';
  $d_o['relationships']['offers_wants_categories_tid']['required'] = TRUE;
  $d_o['defaults']['fields'] = FALSE;
  /* Field: Taxonomy term: Name */
  $d_o['fields']['name_1']['id'] = 'name_1';
  $d_o['fields']['name_1']['table'] = 'taxonomy_term_data';
  $d_o['fields']['name_1']['field'] = 'name';
  $d_o['fields']['name_1']['relationship'] = 'offers_wants_categories_tid';
  $d_o['fields']['name_1']['label'] = '';
  $d_o['fields']['name_1']['exclude'] = TRUE;
  $d_o['fields']['name_1']['element_label_colon'] = FALSE;
  /* Field: Content: Title */
  $d_o['fields']['title']['id'] = 'title';
  $d_o['fields']['title']['table'] = 'node';
  $d_o['fields']['title']['field'] = 'title';
  $d_o['fields']['title']['label'] = 'Description';
  /* Field: User: Name */
  $d_o['fields']['name']['id'] = 'name';
  $d_o['fields']['name']['table'] = 'users';
  $d_o['fields']['name']['field'] = 'name';
  $d_o['fields']['name']['relationship'] = 'uid';
  $d_o['fields']['name']['label'] = 'Member';
  /* Field: Content: Types d'offres/demandes */
  $d_o['fields']['offers_wants_types']['id'] = 'offers_wants_types';
  $d_o['fields']['offers_wants_types']['table'] = 'field_data_offers_wants_types';
  $d_o['fields']['offers_wants_types']['field'] = 'offers_wants_types';
  $d_o['fields']['offers_wants_types']['hide_alter_empty'] = FALSE;
  $d_o['fields']['offers_wants_types']['delta_offset'] = '0';
  $d_o['defaults']['arguments'] = FALSE;
  $d_o['path'] = 'offers/print';
  $d_o['displays'] = array(
    'all' => 'all',
  );

  /* Display: print-table category */
  $handler = $view->new_display('print-table', 'print-table category', 'print_table_category');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['access'] = FALSE;
  $d_o['access']['type'] = 'role';
  $d_o['access']['role'] = array(RID_COMMITTEE => RID_COMMITTEE);
  $d_o['pager']['type'] = 'none';
  $d_o['path'] = 'offers/print/%';


  /* Display: Export to XLS */
  $xls_filename = ($want ? t('wants')  : t('offers')).'.xls';
  $handler = $view->new_display('views_data_export', 'Export to XLS', 'views_data_export_2');
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['hide_admin_links'] = FALSE;
  $d_o['defaults']['access'] = FALSE;
  $d_o['access']['type'] = 'perm';
  $d_o['access']['perm'] = 'edit propositions';
  $d_o['pager']['type'] = 'none';
  $d_o['pager']['options']['offset'] = '0';
  $d_o['style_plugin'] = 'views_data_export_xls';
  $d_o['style_options']['provide_file'] = 1;
  $d_o['style_options']['filename'] = $xls_filename;
  $d_o['style_options']['parent_sort'] = 0;
  $d_o['path'] = $xls_filename;
  $d_o['defaults']['fields'] = FALSE;
  /* Field: Content: Title */
  $d_o['fields']['title']['id'] = 'title';
  $d_o['fields']['title']['table'] = 'node';
  $d_o['fields']['title']['field'] = 'title';
  $d_o['fields']['title']['label'] = 'Intitulé';
  /* Field: Field: Catégories d'offres et de demandes */
  $d_o['fields']['offers_wants_categories']['id'] = 'offers_wants_categories';
  $d_o['fields']['offers_wants_categories']['table'] = 'field_data_offers_wants_categories';
  $d_o['fields']['offers_wants_categories']['field'] = 'offers_wants_categories';
  $d_o['fields']['offers_wants_categories']['label'] = 'Catégories';
  $d_o['fields']['offers_wants_categories']['delta_offset'] = '0';
  /* Field: Content: Corps */
  $d_o['fields']['body']['id'] = 'body';
  $d_o['fields']['body']['table'] = 'field_data_body';
  $d_o['fields']['body']['field'] = 'body';
  $d_o['fields']['body']['label'] = 'Description';
  $d_o['fields']['body']['type'] = 'text_summary_or_trimmed';
  $d_o['fields']['body']['settings'] = array(
    'trim_length' => '600',
  );
  /* Field: Propositions: Expiry date */
  $d_o['fields']['end']['id'] = 'end';
  $d_o['fields']['end']['table'] = 'offers_wants';
  $d_o['fields']['end']['field'] = 'end';
  $d_o['fields']['end']['label'] = 'Expires on';
  $d_o['fields']['end']['date_format'] = 'short';
  /* Field: User: Uid */
  $d_o['fields']['uid']['id'] = 'uid';
  $d_o['fields']['uid']['table'] = 'users';
  $d_o['fields']['uid']['field'] = 'uid';
  $d_o['fields']['uid']['relationship'] = 'uid';
  $d_o['fields']['uid']['label'] = 'N°';
  /* Field: User: Nom et adresse - First name */
  $d_o['fields']['profile_address_first_name']['id'] = 'profile_address_first_name';
  $d_o['fields']['profile_address_first_name']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_first_name']['field'] = 'profile_address_first_name';
  $d_o['fields']['profile_address_first_name']['relationship'] = 'uid';
  $d_o['fields']['profile_address_first_name']['label'] = 'Prénom';
  /* Field: User: Nom et adresse - Last name */
  $d_o['fields']['profile_address_last_name']['id'] = 'profile_address_last_name';
  $d_o['fields']['profile_address_last_name']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_last_name']['field'] = 'profile_address_last_name';
  $d_o['fields']['profile_address_last_name']['relationship'] = 'uid';
  $d_o['fields']['profile_address_last_name']['label'] = 'Nom';
  /* Field: User: Numéros de téléphone */
  $d_o['fields']['profile_phones']['id'] = 'profile_phones';
  $d_o['fields']['profile_phones']['table'] = 'field_data_profile_phones';
  $d_o['fields']['profile_phones']['field'] = 'profile_phones';
  $d_o['fields']['profile_phones']['relationship'] = 'uid';
  $d_o['fields']['profile_phones']['label'] = 'Téléphone';
  $d_o['fields']['profile_phones']['delta_offset'] = '0';
  /* Field: User: Nom et adresse - Locality (i.e. City) */
  $d_o['fields']['profile_address_locality']['id'] = 'profile_address_locality';
  $d_o['fields']['profile_address_locality']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_locality']['field'] = 'profile_address_locality';
  $d_o['fields']['profile_address_locality']['relationship'] = 'uid';
  $d_o['fields']['profile_address_locality']['label'] = 'Ville ou commune';
  /* Field: User: Neighbourhood */
  $d_o['fields']['profile_address_dependent_locality']['id'] = 'profile_address_dependent_locality';
  $d_o['fields']['profile_address_dependent_locality']['table'] = 'field_data_profile_address';
  $d_o['fields']['profile_address_dependent_locality']['field'] = 'profile_address_dependent_locality';
  $d_o['fields']['profile_address_dependent_locality']['relationship'] = 'uid';
  $d_o['displays'] = array(
    'all' => 'all',
  );
  $d_o['use_batch'] = 'batch';

  //get all the terms in the types vocab and add a display for each.
  $tids = _yell_type_tids();
  if (count($tids) > 1) {
    foreach($tids as $tid) {
      _yell_views_add_proptype($view, $tid, $want);
    }
    //sort out the tabs for the proptype menu items
  }
  return $view;
}

function _yell_type_tids() {
  return db_query("SELECT tid FROM {taxonomy_term_data} d LEFT JOIN {taxonomy_vocabulary} v ON v.vid = d.vid WHERE v.machine_name = :name",
    array(':name' => 'offers_wants_types')
  )->fetchCol();
}

/*
 * add a display for each of the terms in the proptypes vocab
 * inherits most things from the default display
 */
function _yell_views_add_proptype(&$view, $tid, $want) {
  $term = taxonomy_term_load($tid);
  $handler = $view->new_display('page', $term->name, 'tab-'.$term->tid);
  $d_o = &$handler->display->display_options;
  $d_o['defaults']['title'] = FALSE;
  $d_o['title'] = $term->name;
  $d_o['defaults']['filters'] = FALSE;
  /* Filter criterion: Content: Type */
  $d_o['filters']['type']['id'] = 'type';
  $d_o['filters']['type']['table'] = 'node';
  $d_o['filters']['type']['field'] = 'type';
  $d_o['filters']['type']['value'] = array(
      'proposition' => 'proposition',
  );
  $d_o['filters']['type']['expose']['operator'] = FALSE;
  /* Filter criterion: Content: Published or admin */
  $d_o['filters']['status_extra']['id'] = 'status_extra';
  $d_o['filters']['status_extra']['table'] = 'node';
  $d_o['filters']['status_extra']['field'] = 'status_extra';
  /* Filter criterion: User: Active */
  $d_o['filters']['status']['id'] = 'status';
  $d_o['filters']['status']['table'] = 'users';
  $d_o['filters']['status']['field'] = 'status';
  $d_o['filters']['status']['relationship'] = 'uid';
  $d_o['filters']['status']['value'] = '1';
  $d_o['filters']['status']['expose']['operator'] = FALSE;
  /* Filter criterion: Propositions: Is a want */
  $d_o['filters']['want']['id'] = 'want';
  $d_o['filters']['want']['table'] = 'offers_wants';
  $d_o['filters']['want']['field'] = 'want';
  $d_o['filters']['want']['value'] = $want;
  /* Filter criterion: Content: Offer/want types (offers_wants_types) */
  $d_o['filters']['field_proptypes_tid']['id'] = 'offers_wants_types_tid';
  $d_o['filters']['field_proptypes_tid']['table'] = 'field_data_offers_wants_types';
  $d_o['filters']['field_proptypes_tid']['field'] = 'offers_wants_types_tid';
  $d_o['filters']['field_proptypes_tid']['value'] = array( 0 => $tid);
  $d_o['filters']['field_proptypes_tid']['type'] = 'select';
  $d_o['filters']['field_proptypes_tid']['vocabulary'] = 'offers_wants_types';
  /* page display settings */
  $d_o['path'] = ($want ? 'wants/' : 'offers/') . $tid;
  $d_o['menu']['type'] = 'tab';
  $d_o['menu']['title'] = $term->name;
  $d_o['menu']['weight'] = $term->weight;
}


/**
 * Implements hook_views_default_views().
 *
 * Set the weights of the menu items. The print-table options are set here coz
 * I can't see what's overriding the defaults
 */
function cforge_yell_views_default_views_alter(&$views) {
  $views['ow_offers']->display['all']->display_options['tab_options']['weight'] = 1;
  if (array_key_exists('ow_wants', $views)) {
    $views['ow_wants']->display['all']->display_options['tab_options']['weight'] = 3;
  }
}

