 <?php

/**
 * @file
 * reveal the sub-locality district
 */

$plugin = array(
  'title' => t('Neighbourhood & Cforge preferences'),
  'format callback' => 'addressfield_format_neighbourhood_generate',
  'type' => 'neighbourhood',
  'weight' => 100,
);

/**
 * Format callback.
 *
 * @see CALLBACK_addressfield_format_callback()
 */
function addressfield_format_neighbourhood_generate(&$format, $address, $context = array()) {
  unset($format['street_block']['premise']);
  unset($format['locality_block']['administrative_area']);
  $format['locality_block'] = array('dependent_locality' => array(
    '#title' => t('Neighbourhood'),
    '#required' => TRUE,
    '#size' => 20,
    '#attributes' => array('class' => array('organisation-name')),
    '#suffix' => '<br />'
  )) + $format['locality_block'];
  $format['street_block']['thoroughfare']['#title'] = t('Street address');
  $format['name_block']['first_name']['#size'] = 12;
  $format['name_block']['last_name']['#size'] = 12;

  //unrequire all these fields for now. We're not here to spy!
  $format['name_block']['last_name']['#required'] = FALSE;
  if (isset($format['street_block']['thoroughfare'])) {
    $format['street_block']['thoroughfare']['#required'] = FALSE;
  }
  if (isset($format['locality_block']['locality'])) {
    $format['locality_block']['locality']['#required'] = FALSE;
  }
  if (isset($format['locality_block']['postal_code'])) {
    $format['locality_block']['postal_code']['#required'] = FALSE;
  }
  $neighbourhood_widget = &$format['locality_block']['dependent_locality'];

  if ($neighbourhoods = variable_get('cforge_neighbourhoods')) {
    $neighbourhood_widget = &$form['profile_address'][LANGUAGE_NONE][0]['locality_block']['dependent_locality'];
    $neighbourhood_widget['#type'] = 'select';
    $neighbourhood_widget['#options'] = drupal_map_assoc(preg_split("/\r\n|\n|\r/", $neighbourhoods));
  }
  elseif (user_access('administer nodes')) {
    $form['profile_address'][LANGUAGE_NONE][0]['locality_block']['dependent_locality']['#description'] = t('Preset the list of neighbourhoods here: @url', array('@url' => url('admin/config/cforge')));
  }
}
